'codetree.bmx

SuperStrict

Import "datanodes.bmx"

Type TCodeNode Extends TDataNode
	Field	pos:Int , count:Int
	Field	returns$
	Field	args$
	Field	fullname$
	Field 	issimple:Int

?debug
	Method New() 
		_typename="TCodeNode"
	End Method
?

	Method SyncValues(snap:TNewDataNode) 
		Local	n:TCodeNode
		Super.SyncValues(snap)
		n = TCodeNode(snap)
		If Not n Then DebugStop() ' oops!  How did I get called?!?  Asked to sync without something that is of different type to me!!!
		pos = n.pos
		count = n.count		
	End Method	

	Method SetName(n$)
		Local	p:Int , p2:Int
	
		p=n.find("'")
		If p <> - 1 Then
			' check if we are inside a string
			While p < n.Length
				Local b:Int = n.FindLast( "~q", n.Length-p)
				Local e:Int = n.Find( "~q", p)
				If (b<>-1 And e<>-1) And (p > b And p < e) Then
					' inside string, find next
					p = n.Find( "'", e)
					If p = -1 Then Exit
				Else
					' last comment, remove it
					n = n[..p]
					Exit
				EndIf
			Wend
		EndIf
		fullname = n.Trim()
		
		' simple nodes dont need extra parsing
		If issimple Then 
			Super.SetName(n)
			Return
		EndIf

		p = n.Find("(")
		If p>-1 Then
			p2 = n.find(")")
			args$ = n[p + 1..p2 - 1]
			n = n[..p]
		End If

		p = n.find(":")
		If p>-1 Then
			returns = n[p + 1..]
			n = n[..p]
		EndIf

		p = n.find("=")
		If p>-1 Then n = n[..p]

		p = n.find("$")
		If p>-1 Then n = n[..p]

		p = n.find("%")
		If p>-1 Then n = n[..p]

		p = n.find("[")
		If p>-1 Then n = n[..p]

		Super.SetName(n)
	End Method

	Method AddCodeNode:TCodeNode(codepanel:TBase,n$,p0:Int,p1:Int, issimple:Int = False)
		Local	c:TCodeNode

		c = New TCodeNode
		c.setaction(TOOLACTIVATE , codepanel , TOOLNAVIGATE , [p0])
		c.setaction(TOOLSELECT , codepanel , TOOLHELP , n$)
		c.issimple = issimple
		c.setname n$
		c.pos=p0
		c.count=p1-p0
		Append c
		Return c
	End Method
End Type

