SuperStrict
Import "tool.bmx"
Import "datanodes.bmx"
Import "options.bmx"

'TODO: These two need to be sorted into:
'       - a generic TGUINavTree component
'       - a generic TGUINavTabber component (note this will need to work with other TGUIPanels, especially code panels)
'       - a single TGUIPanel that contains one of each of these
'         (this last would be a stop-gap measure until we've got a fully configurable IDE?)

Type TNodeView Extends TGUIPanel 'TODO: TNodeView should extend TGUINavigator
	Field	owner:TNavBar
	Field	root:TDataNode
	Field	treeview:TGadget
	Field	index:Int
	Field	options:TToolsOptions

	Method NewView()
		Local	n:TDataNode,hnode:TGadget
		hnode=SelectedTreeViewNode(treeview)
		n=root.FindNode(hnode,index)
		If n And n._parent owner.AddView n
	End Method

	Method Invoke:Object(command:Int,argument:Object)
		'TODO: TNodeView.Invoke is just a stub
		'This is just a stub at the moment, but probably should support some
		' of the tool commands, e.g. TOOLREFRESH, TOOLGOTO, etc.
	End Method

	Method Query:Int(property:Int)
		' there are no properties to query
	End Method

	Method Poll(e:TEvent)
		Local	n:TDataNode
		n=root.FindNode(TGadget(e.extra),index)
		If Not n Return
		Select e.id
			Case EVENT_GADGETSELECT
				n.invoke(TOOLSELECT)
			Case EVENT_GADGETACTION
				n.invoke(TOOLACTIVATE)
			Case EVENT_GADGETMENU
				n.invoke(TOOLMENU,[Self])
			Case EVENT_GADGETOPEN
				n.open index
			Case EVENT_GADGETCLOSE
				n.close index
		End Select
	End Method

	Method Initialize(parent:TGUIContainer , target:TGUIPanelGroup)
		'TODO: nodeview.initialize does nothing for now
	End Method

	'TODO: This create is the old create method - need moving into Initialize
	Method Create:TNodeView(o:TNavBar,node:TDataNode,i:Int)
		owner = o
		root = node
		index = i
		treeview=CreateTreeView(0,0,ClientWidth(o.gadget()),ClientHeight(o.gadget()),o.gadget())
		SetGadgetLayout treeview,1,1,1,1
		HideGadget treeview
		Return Self
	End Method

	Method Refresh() ; End Method ' does nothing for now
End Type

'This type wraps up the navbars (a tabber + set of treeviews)

Type TNavBar Extends TGUIPanel
	Field	_navtab:TGUINavTabber
	Field	viewlist:TList=New TList
	Field	selected:TNodeView
	Field	options:TToolsOptions

	Method Hide()
		_navtab.hide()
	End Method

	Method Show()
		_navtab.show()
	End Method

	Method  SelectedView:Int()
		If selected Return selected.index
	End Method

	Method SelectView(index:Int)
		Local	n:TNodeView
		
		If index>=viewlist.count() Return
		n=TNodeView(viewlist.ValueAtIndex(index))
		If Not n Print "selectview failed";Return
		If n<>selected
			If selected HideGadget selected.treeview
			selected=n
		EndIf
		ShowGadget n.treeview
		SelectGadgetItem _navtab.gadget(),index
	End Method

	Method AddView:Int(node:TDataNode,icon:Int=-1)
		Local	n:TNodeView
		Local	index:Int , root:TGadget

		' First of all, check that we haven't already got a treeview with this node in it
		For n=EachIn viewlist
			If n.root=node Then SelectView n.index;Return 0
		Next
		
		' create  a new tree
		n=New TNodeView.Create(Self,node,viewlist.Count())
		options.navstyle.Apply n.treeview
		viewlist.AddLast n
		
		' add a tab to the tabber
'		AddGadgetItem _navtab.gadget() , node._name , 0 , icon
		_navtab.addnavigation(node._name , Null , icon)
		
		' locate the root node of the treeview
		root = TreeViewRoot(n.treeview)
		
		' tell our node that was passed in about the treeviewroot we just created for it
		node.setnode root,n.index
		SelectView n.index
		Return n.index
	End Method

	Method Poll(e:TEvent)
		If e.source=_navtab.gadget()
			SelectView SelectedGadgetItem(_navtab.gadget())
		End If
		If selected And e.source=selected.treeview
			selected.Poll(e)
		EndIf
	End Method

	Method Refresh()
		Local	view:TNodeView
		For view=EachIn viewlist
			options.navstyle.Apply view.treeview
		Next
	End Method

	Method Invoke:Object(command% , argument:Object = Null)
		If command=TOOLREFRESH Refresh()
	End Method

	Method Query:Int(property:Int)
		' there are no properties to query
	End Method

	Function Create:TNavBar(win:TGUIContainer,o:TToolsOptions,is:TIconStrip=Null )	',root:TDataNode)
		Local	n:TNavBar
		Local 	navtab:TGUINavTabber

		n=New TNavBar
		n.options = o
		navtab = New TGUINavTabber
		navtab.initialize(win,Null,is)
		n._navtab = navtab
		Return n
	End Function

	Method Gadget:TGadget()
		Return _navtab.gadget()
	End Method

End Type

