'TODO: this file needs tidying up such that it can be an import, not an include
'SuperStrict
'Import "debugtree.bmx"
'Import "bytebuffer.bmx"
'Import "options.bmx"
'Include "miscfuncs.bmx"

Type TGUIOutput Extends TGUIPanel	'used build and run

	Field	host:TBMXHost 'TODO: Probably should be THost, but needs build process sorting in THost / TBMXHost first!
	Field	output:TGadget
	Field	debugtree:TDebugTree
	Field	process:TProcess
	Field	user$ , cmdline$ , err$ , post$
	Field	posttool:TBase ' where did I get triggerred from?
	Field	errbuffer:TByteBuffer
	Field	outputmenu:TGadget
	Field	options:TBuildOptions
	Field	stepping:Int
	Field	pipe:TStream
	Field	_timer:TTimer
	
	Method ClearDumpRequests()
		For Local o:TObj = EachIn debugtree.objlist
			o.HasSynced(o.sync_count)
		Next
	EndMethod
	
	Method SendDumpRequests()
		For Local o:TObj = EachIn debugtree.objlist
			If o.syncnext Then
				If o.addr <> "00000000" Then WritePipe "d"+o.addr
				o.HasSynced( debugtree.sync_count )
				'PollSystem()	'ReadPipes() on timertick, and checks for Stepping
			EndIf
		Next
	EndMethod

	Method Clear()
		If Not output Open()
		SetTextAreaText output,""
	End Method

	Method Write(mess$)
		If Not output Open()
		mess=mess.Replace$(Chr(0),"")
		AddTextAreaText output,mess
	End Method

	Method Execute(cmd$ , mess$ = "" , exe$ = "" , home:Int = True,owner:TBase=Null)
		stepping=False
		If Not output Open()
		If Not mess$ mess$=cmd$
		err$=""
		post$ = exe
		posttool=owner
		host.SelectPanel Self
		debugtree.Reset
		If process And ProcessStatus(process)
			Delay 500
			If ProcessStatus(process)
				Notify "@@output_panel/process_busy|"+cmdline
				Return
			EndIf
		EndIf
		cmd = cmd.Trim() 
		If _timer=Null Then _timer = CreateTimer(10) ' create a timer that will trigger us to read from the pipe
		process=CreateProcess(cmd$,HIDECONSOLE)
		If Not process Notify "@@output_panel/process_failure|"+cmd;Return
		If Not process.status() Notify "@@output_panel/process_start_failure|" + cmd ; process = Null ; Return
		pipe=process.pipe
'		pipe=TTextStream.Create(Process.pipe,TTextStream.UTF8)
		cmdline=cmd
		If home Clear
		Write Translate(mess$)+"~n"
		errbuffer=New TByteBuffer
		host.RefreshToolbar
	End Method

	Method WritePipe(l$)
		If pipe Then pipe.WriteLine(l$)
	End Method

	Method Go()
		ClearDumpRequests()
		WritePipe "r"
		stepping=False
	End Method

	Method StepOver()
		ClearDumpRequests()
		WritePipe "s"
		stepping=True
	End Method

	Method StepIn()
		ClearDumpRequests()
		WritePipe "e"
		stepping=True
	End Method

	Method StepOut()
		ClearDumpRequests()
		WritePipe "l"
		stepping=True
	End Method

	Method Stop()
		If Not process Return
'attempted to add some code to halt execution, but this would need changes to debugger.stdio.bmx...
'		If stepping Then
			process.Terminate
			FlushPipes process.pipe,process.err
			process.Close
			process = Null
?Not linux			
'TODO: reinstate this once BlitzMax StopTimer command fixed so that it doesn't cause issues with WaitEvent afterwards
			If _timer Then
				StopTimer _timer
				_timer = Null
			EndIf
?
			Write "~n" + LanguageString("output_panel/process_terminated") + "~n"
			host.DebugExit
			Close
			stepping=False
'		Else
'			WritePipe "DebugStop:~n"  'this is the problem - we need a means of telling the debug code to stop the program...
'			Write "~n" + LanguageString("output_panel/process_halted") + "~n"
'			stepping = True
'		EndIf
	End Method

	Method Wait()
		While process And process.status()
			PollSystem
		Wend
	End Method

	Method Invoke:Object(command:Int,argument:Object=Null)
		Select command
			Case TOOLSHOW
				host.SetTitle
				If output Then ActivateGadget output
			Case TOOLNAVIGATE
				Local pos:Int=Int[](argument)[0]
				host.SelectPanel Self
				SelectTextAreaText output,TextAreaLine(output,pos),0,TEXTAREA_LINES
				SelectTextAreaText output,TextAreaLine(output,pos),1,TEXTAREA_LINES
				ActivateGadget output
			Case TOOLCLOSE
				host.RemovePanel Self
				output=Null
			Case TOOLCUT
				GadgetCut output
			Case TOOLCOPY
				GadgetCopy output
			Case TOOLPASTE
				GadgetPaste output
			Case TOOLSELECTALL
				If output SelectTextAreaText output
			Case TOOLREFRESH
				Refresh()
		End Select
	End Method

	Method Query:Int(property:Int)
		' there are no properties to query
	End Method

	Method Refresh()
		options.outputstyle.apply output
	End Method

	Method Close()
		host.SelectActivePanel()
		stepping=False
	End Method

	Method Escape()
		Stop
		Close
		stepping=False
	End Method

	Function outputfilter:Int(event:TEvent,context:Object)
		Local out:TGUIOutput=TGUIOutput(context)
		If Not out Return 0
		Select event.id
			Case EVENT_KEYDOWN
				If event.data=27
					out.Escape()
					Return 0
				EndIf
			Case EVENT_KEYCHAR
'				Print "output_keychar "+event.data
				out.writechar(event.data)
		End Select
		Return 1
	End Function

	Method Poll(e:TEvent) 
		If Not e.source Then Return
		
		If e.source=output
			If e.id=EVENT_GADGETMENU
				PopupWindowMenu host.gadget(),outputmenu
			EndIf
		EndIf

		If _timer <> Null And e.source = _timer Then
			If Not process Then ' if not running, stop the timer (no point coming in here every 1/10th second!
?Not linux			
'TODO: reinstate this once BlitzMax StopTimer command fixed
				StopTimer _timer
				_timer=Null			
?
			Else
				'if still running, grab any new data from the pipe
				ReadPipes process.pipe , process.err
				Local status:Int=process.status()
				If status = 0				
					process.terminate
					FlushPipes process.pipe,process.err
					process.close
					process=Null
					Write "~n" + LanguageString("output_panel/process_complete") + "~n"
					host.DebugExit
					host.SelectPanel Self
		
					err = err.Trim()
					If err
						' try using senders error parsing via TOOLPARSEERROR
						Local sender:TBase = TBase(posttool)
						If sender Then
							Local res:String = String(sender.Invoke( TOOLPARSEERROR, err))
							If Not Int(res) Then
								' use host default error parser
								host.ParseError( cmdline, err)
							EndIf
						Else
							' use host default error parser
							host.ParseError( cmdline, err)
						EndIf
					Else
						If post$
							Local menuaction:Int=Int(post)
							If menuaction
								host.OnMenu menuaction,posttool
							Else
		'						Execute post$,"","",False,0
							EndIf
						Else
							If options.hideoutput Close
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	End Method

	Method FlushPipes(pipe:TPipeStream,errpipe:TPipeStream)
		ReadPipes(pipe,errpipe)
		Local bytes:Byte[]=errbuffer.flushbytes()
		If bytes
			Local line$=String.FromBytes(bytes,Len bytes)
			line=line.Replace$(Chr(13),"")
			If line<>">" Write line
		EndIf
	End Method

	Method ReadPipes(pipe:TPipeStream,errpipe:TPipeStream)
		Local	status:Int
		Local	bytes:Byte[],line$

		bytes = pipe.ReadPipe()
		If bytes
			'TODO: Should really consider getting rid of this UTF8 conversion and using built in blitzmax unicode strings as of v1.32
			line$=UTF8BytesToString$(bytes)
			line=line.Replace$(Chr(13),"")
			line=line.Replace$(Chr(0),"")
			Write line
		EndIf

		bytes=errpipe.ReadPipe()
		If bytes Then errbuffer.WriteBytes bytes,Len bytes Else SendDumpRequests()

'		If bytes Write String.FromBytes(bytes,bytes.length)
		While errbuffer.LineAvail() 
			line$ = errbuffer.ReadLine() 
			line = debugtree.ProcessError(line) 
			If line
				Write line+"~n"
				err:+line+"~n"
			EndIf
		Wend
	End Method

	Method WriteChar(char:Int)
		Local	pipe:TPipeStream
		If Not process Return
		pipe=process.pipe
		If char=3			'CTRL-C
			Stop()
		EndIf
		If char=13			'ENTER
'			Write Chr(10)
			pipe.WriteLine user$
			user$=""
		EndIf
		If char=8			'DELETE
			If Len user
'				Local pos=TextAreaLen(output)
'				If pos SetTextAreaText output,"",pos-1,1,TEXTAREA_CHARS
				user=user[..Len user-1]
			EndIf
		EndIf
		If char>31
'			Write Chr(char)
			user:+Chr(char)
		EndIf
	End Method

	Method Open()
		If output Then 
			FreeGadget output
			output=Null
		Else
			host.addpanel(Self)
		EndIf
		output=CreateTextArea(0,0,ClientWidth(panel),ClientHeight(panel),panel,TEXTAREA_WORDWRAP And options.wordwrap)
		SetGadgetLayout output,1,1,1,1
		options.outputstyle.apply output
		SetGadgetFilter output , outputfilter , Self	
		host.SelectPanel Self
	End Method

	Function CreateOutputMenu:TGadget()
		Local	edit:TGadget

		LanguageSetGroup "output_context_menu"

		edit=CreateMenu("@@edit",0,Null)
		CreateMenu "@@cut",MENUCUT,edit
		CreateMenu "@@copy",MENUCOPY,edit
		CreateMenu "@@paste",MENUPASTE,edit
		CreateMenu "",0,edit
		CreateMenu "@@stop",MENUSTOP,edit
		Return edit
	End Function

	Function Create:TGUIOutput (host:TBMXHost,opt:TBuildOptions,dp:TDebugTree)
		Local	o:TGUIOutput
		o=New TGUIOutput
		o.options=opt
		o.host = host
		o.debugtree = dp
		o.name="@@output_panel/title"
		o.outputmenu = CreateOutputMenu() 
'		o.Open
		Return o
	End Function
	
End Type


