SuperStrict
Import brl.blitz

Type TDiff
	Field	pos:Int		'the previous cursor pos
	Field	count:Int		'and previous selection area
	Field	del$			'the text being deleted in this diff
	Field	add$			'the text being added in this diff
	Field	pos0:Int		'the new cursor pos
	Field	count0:Int	'and the new selection area
	Field	pos1:Int		'where in the text add / del start at
	
	Method AppendIfMinor:Int(d:TDiff)

		'the new diff must relate to the old diff in terms of prev / new cursor position
		If d.pos<>pos0 Then Return False
		'if more than just one char has been added / deleted, then we will NOT append it
		If d.del.length + d.add.length > 1 Then Return False
		'if the existing diff (self) related to a selected area, don't join it up to the new one
		If count > 0 Or count0 > 0 Then Return False
		'if the new diff (d) relates in any way to a selected area, don't join it up to the new one
		If d.count > 0 Or d.count0 > 0 Then Return False

		' okay, we want to do this...provided we're adding more of the same!
		If d.add.length = 1 Then
		
			' check that we're not adding to a previous delete
			If del.length = 0 Then
				'add the new character to the existing edit and return true
				add:+ d.add
				pos0 = d.pos0
				'don't need to update pos1
				Return True
			EndIf
			
		ElseIf d.del.length = 1 Then
					
			' firstly, check that there are additions in the last diff...
			If add.length = 0 Then
				If d.pos0 = d.pos - 1 Then 'AND it's a sequence of backspaces
					del = d.del + del
					pos0 = d.pos0
					pos1 = d.pos1
					Return True
				ElseIf d.pos0 = d.pos Then ' OR it's a sequence of deletes
					del = del + d.del
					' pos0 & pos1 will be unchanged as cursor hasn't moved
					Return True				
				EndIf
			EndIf
			
' While the following check seemed like a valid thing to do, in practice it's a bit annoying 
' to effectively "lose" an undo point, so better Not To merge And have To hit ctrl-z twice!
'
'			' otherwise, only merge if the deletion is at the End of the existing addition (already checked above)
'			' and the char being deleted matches the last char
'			If d.del[0] = add[add.length - 1] Then
'				add = add[..add.length - 1]
'				pos0 = d.pos0
'				'don't need to update pos1
'				Return True
'			EndIf
			
		EndIf
		Return False ' failsafe pass-thru
	End Method
End Type
