// language.m - Localised application-menu for Mac OS

#include <AppKit/AppKit.h>

#include <brl.mod/blitz.mod/blitz.h>
#include <maxgui.mod/maxgui.mod/maxgui.h>

NSString *copy_NSStringFromBBString(BBString *s)
{
	return [NSString stringWithCharacters:s->buf length:s->length];
}

void LocaliseAppMenu(BBString *hide, BBString *hideothers, BBString *show, BBString *quit)
{
	NSString *ns_hide, *ns_hideothers, *ns_show, *ns_quit;
	ns_hide=copy_NSStringFromBBString(hide);
	ns_hideothers=copy_NSStringFromBBString(hideothers);
	ns_show=copy_NSStringFromBBString(show);
	ns_quit=copy_NSStringFromBBString(quit);
	
	NSMenu *mainmenu=[NSApp mainMenu];
	NSMenuItem* appmenuitem=[mainmenu itemAtIndex:0];
	NSMenu* appmenu=[appmenuitem submenu];
	NSMenuItem* menuitem;
	menuitem=[appmenu itemAtIndex:0]; // "Hide <Application>"
	[menuitem setTitle:ns_hide];
	menuitem=[appmenu itemAtIndex:1]; // "Hide Others"
	[menuitem setTitle:ns_hideothers];
	menuitem=[appmenu itemAtIndex:2]; // "Show All"
	[menuitem setTitle:ns_show];
	menuitem=[appmenu itemAtIndex:4]; // "Quit <Application>"
	[menuitem setTitle:ns_quit];
}