'
' BlitzMax Integrated Development Environment - Community Edition
' ===============================================================
'
' Originally released by Blitz Research Limited in 2005 under the Blitz Shared Source Code License
' and released into the Public Domain in 2006 for the benefit of the community.
'
' This is the free Community Edition version, maintained at:
'   http://sourceforge.net/projects/blitzmax-ide/
'
' Requires BRL.MaxGui modules to compile

SuperStrict

Framework BRL.Blitz

?Win32
' main icon for windows
'Import "resources/resources.o"
?

' Import the relevant BRL / PUB modules
Import brl.standardio
Import brl.retro
Import brl.filesystem
Import brl.system
Import pub.freeprocess
Import brl.pngloader
Import brl.timer
Import brl.maxutil
Import pub.macos ' for ExportMod on MacOS
Import maxgui.proxygadgets

' Import the generic code used by the IDE
Import "util/bytebuffer.bmx"		' buffers up a stream
Import "splitter.bmx"		' provides the GUI splitter 'gadget'
Import "requestmultifile.bmx"	' Import multiple file requester
Import "singleinstance.bmx"	' Import single instance helper

'Import the MaxIDE specific stuff
Import "style.bmx"			' provides functionality to specify and manage text styles
Import "host.bmx"			' provides base IDE functionality
Import "requesters.bmx"		' provides all of the MaxIDE specific requesters
Import "projects.bmx"		' provides all project based functionality
Import "debugtree.bmx"		' debugging code
Import "help.bmx"			' all help stuff
Import "todo.bmx"			' todo viewing stuff
Import "codetree.bmx"		' code tree stuff
Import "options.bmx"		' code relating to options
Import "optionsgui.bmx"		' GUI for setting options
Import "datanodeview.bmx"	' the navigation bar on the side
Import "version.bmx"		' the versioning file
Import "tool_svn.bmx"		' Subversion support
Import "icons.bmx"			' icons and related constants
'Import "imagepanel.bmx"		' image viewer

'TODO: The following should be in editor.bmx once it's a module
Import "diff.bmx"			' difference
Include "autocomplete.bmx"	' autocomplete window
Include "debug.bmx"			' debugging code (output panel)
Include "editor.bmx"		' code editor
'Include "tool_bmxsyncmods.bmx"	' BlitzMax syncmods tool
Include "tool_buildmods.bmx"	' Build Modules support
Include "bmxhost.bmx"		' main code block for the IDE (host)
' Notes: on dependent Imports:
'  language.bmx has been imported in tool.bmx

?debug
Include "util/memchecktool.bmx"
?

'TODO: debug.bmx should be an import really, not an include
'TODO: editor.bmx should be an import really, not an include
'TODO: tool_bmxsyncmods.bmx should be an import really, not an include
'TODO: bmxhost.bmx should be an import really, not an include

'---------------------------------------------------------------

' Start MaxIDE
Global maxide:TBMXHost
maxide = New TBMXHost
maxide.Initialize()

While maxide.running
	maxide.Poll()
Wend

End
