'options-test.bmx

' this file is solely used to test out the options functionality.
' It can legitimately be used as a standalone option setting program, but that
' seems pretty pointless!
SuperStrict
Framework brl.blitz
Import maxgui.drivers
Import "optionsgui.bmx"
Import "locale/language.bmx"

?win32
Import "resources/resources.o"
?

' create a dummy host to attach the reQuester to
Local host:TSimpleHost=New TSimpleHost

' create the options screen and panels (it will work out which panels are needed based on what options you loaded above)
host.initialize
host.show

' and show the requester
Local o:TGUIElement = TOptionsRequester.Create(host , host.options)
o.show

' main loop - note everything is controlled through the dummy host
While host.running
	WaitEvent()
	host.poll(CurrentEvent)
Wend

End


' the type below is a very simple host, only intended for use in testing stuff out
Type TSimpleHost Extends TGUIHost Final

	Field options:TOptionsGroup

	Method SetTitle(n$="") ;End Method
	Method SetStatus(text$)  ;End Method

	Method SelectPanel(panel:TGUIPanel)  ;End Method
	Method AddPanel(tabpanel:TGUIPanel)  ;End Method
	Method RemovePanel(tabpanel:TGUIPanel) ;End Method
	Method RefreshPanel(tabpanel:TGUIPanel)  ;End Method
	Method RefreshToolbar()  ;End Method
	Method RefreshAll() ; End Method
	Method Refresh()  ;End Method
	Method GetCommandLine$()  ;End Method
	Method SetCommandLine(text$)  ;End Method
	Method Execute(cmd$,mess$="",post$="",home:Int=True,tool:TBase=Null) ;End Method
	Method OpenSource:Object(path$,temp:Int=False)  ;End Method
	Method OpenSourceAt:Object(path$,line:Int,column:Int)  ;End Method
	Method IsSourceOpen(path$)  ;End Method
	Method SetMode(m:Int)  ;End Method
	Method WritePipe(text$)  ;End Method
	Method DebugSource(path$ , line:Int , column:Int) ; End Method
	Method UpdateOptions() ; End Method
	Method ShowHelp$(subject$="") ; End Method
	Method AddRecent(file$) ; End Method
	Method AddOpenFile(file$) ; End Method

	Method Initialize() 

		' first we create an options group to hold all of our options
		Local h:TOptionsGroup = New TOptionsGroup
		
		' next we load the options that we want
		Local o_host:TOptions=New THostOptions.Create(h)
		Local o_editor:TOptions=New TEditorOptions.Create(h)
		Local o_code:TOptions=New TCodeOptions.Create(h)
		Local o_build:TOptions=New TBuildOptions.Create(h)
		Local o_tools:TOptions=New TToolsOptions.Create(h)
		Local o_sync:TOptions = New TSyncOptions.Create(h) 
		Local o_keys:TKeyOptions=New TKeyOptions.Create(h)
		
		' now we load the config
		h.ReadConfig("test.ini")   'should be: bmxpath+"/cfg/ide.ini"
		LanguageLoad 'o_host.languagefile
		options=h

		o_keys.AddHotKeyDef("Help" , KEY_F1 , 0)
		o_keys.AddHotKeyDef("Auto-Complete",KEY_SPACE,MODIFIER_COMMAND)

		' and create a base host window to use
		_gadget=CreateWindow("MaxIDE",200,200,300,300,Null,15|WINDOW_HIDDEN|WINDOW_ACCEPTFILES)
		ShowGadget _gadget
		running=True
	End Method

	Method Poll(e:TEvent)
		Local	src:TGadget

		CheckHandlers(e)

		Select e.ID

			Case EVENT_APPTERMINATE
				running=False

			Case EVENT_WINDOWCLOSE
				src=TGadget(e.source)
				If src=_gadget Then running=False

		End Select
	End Method

	Method DisableHotKeys()
	
	End Method

	Method EnableHotKeys() 

	End Method

End Type


