'optionsgui.bmx

SuperStrict

Import "options.bmx"
Import "stylegadgets.bmx"

Type TOptionsPanel Extends TGUIPanel Abstract
	Field	options:TOptions

	Method InitOptionsPanel(n$ ,host:TGUIContainer) 
		CreateGUIPanel(n$ ,0 , 0 , host.Width(), host.Height() , host)
	End Method

	Function Create:TOptionsPanel(o:TOptions,host:TGUIContainer) Abstract

	Method Invoke:Object(command:Int,argument:Object=Null)
		'there are no invocation relevant to option panels
	End Method

	Method Query:Int(property:Int)
		' there are no properties to query
	End Method

End Type

Type TOptionsRequester Extends TGUIToolWindow
	Field optionsgroup:TOptionsGroup
	Field tabbedpanelgroup:TGUITabbedPanelGroup

	Method InitOptionsRequester(host:TGUIHost,og:TOptionsGroup)
		Local	p:TOptionsPanel
		Local	o:TOptions

		optionsgroup=og
		InitToolWindow(host , "@@options_requester/title" , 400 , 450)
		tabbedpanelgroup = New TGUITabbedPanelGroup
		tabbedpanelgroup.InitTabbedPanelGroup(Self)

		'now create the panels that we need
		' if you need to add a new panel for a new type of option, add it here
		For o=EachIn optionsgroup.optionslist
			If THostOptions(o)<>Null Then
				p = New THostOptionsPanel.Create(o , tabbedpanelgroup.panelgroup())
				tabbedpanelgroup.addpanel p
			ElseIf TEditorOptions(o)<>Null Then
				p = New TEditorOptionsPanel.Create(o , tabbedpanelgroup.panelgroup())
				tabbedpanelgroup.addpanel p
			ElseIf TCodeOptions(o)<>Null Then
				p = New TCodeOptionsPanel.Create(o , tabbedpanelgroup.panelgroup())
				tabbedpanelgroup.addpanel p
			ElseIf TBuildOptions(o)<>Null Then
				p = New TBuildOptionsPanel.Create(o , tabbedpanelgroup.panelgroup())
				tabbedpanelgroup.addpanel p
			ElseIf TToolsOptions (o)<>Null Then
				p = New TToolsOptionsPanel.Create(o , tabbedpanelgroup.panelgroup())
				tabbedpanelgroup.addpanel p
			ElseIf THelpOptions (o)<>Null Then
				p = New THelpOptionsPanel.Create(o , tabbedpanelgroup.panelgroup())
				tabbedpanelgroup.addpanel p
			ElseIf TKeyOptions (o)<>Null Then
				p = New TKeyOptionsPanel.Create(o , tabbedpanelgroup.panelgroup())
				tabbedpanelgroup.addpanel p				
			End If
		Next

		'and get ready to show it
		tabbedpanelgroup.invoke(TOOLNAVIGATE,"")
		optionsgroup.SnapShot
	End Method

	Function Create:TOptionsRequester(host:TGUIHost,options:TOptionsGroup)
		Local	o:TOptionsRequester
		o=New TOptionsRequester
		o.InitOptionsRequester(host,options)
		Return o
	End Function

	Method Poll(e:TEvent)
		'handle any generic events for the reQuester here, and pass on any for the active panel
		Select e.source
			Case _ok
				If e.id=EVENT_GADGETACTION Then
					If optionsgroup.dirty Then
						optionsgroup.WriteConfig()
						TGUIHost(owner).refreshall()
					End If
					Hide()
				End If
			Case _cancel, _gadget
				If e.id=EVENT_GADGETACTION Or e.id=EVENT_WINDOWCLOSE Or e.id=EVENT_APPTERMINATE Then
					optionsgroup.Restore()
					Hide()
				End If
			Default
				tabbedpanelgroup.Poll(e)
		End Select
	End Method

	Method Refresh()
		tabbedpanelgroup.refresh()
	End Method

	Method Invoke:Object(command:Int,argument:Object=Null)
		' there are no invocations relevant to a requester
	End Method

	Method Query:Int(property:Int)
		' there are no properties to query
	End Method

	Method Show()
		TGUIHost(owner).DisableHotKeys()
		Super.show()
	End Method
	
	Method Hide() 
		TGUIHost(owner).EnableHotKeys() 
		Super.Hide() 
	End Method

End Type

Type TEditorOptionsPanel Extends TOptionsPanel
	Field options:TEditorOptions

	'gadgets
	Field textarea:TGadget
	Field styles:TTextStyleGadget[]
	Field editstyle:TGadgetStyleGadget

	Method InitGUI()
		' create any specific gadgets here
		editstyle=TGadgetStyleGadget.Create("@@background",10,10,options.editstyle,panel,TGadgetStyleGadget.BACKGROUND|TGadgetStyleGadget.FONT)

		styles=New TTextStyleGadget[6]
		styles[options.NORMAL]=TTextStyleGadget.Create("@@plain_text",10,40,options.styles[options.NORMAL],panel)
		styles[options.COMMENT]=TTextStyleGadget.Create("@@remarks",10,70,options.styles[options.COMMENT],panel)
		styles[options.QUOTED]=TTextStyleGadget.Create("@@strings",10,100,options.styles[options.QUOTED],panel)
		styles[options.KEYWORD]=TTextStyleGadget.Create("@@keywords",10,130,options.styles[options.KEYWORD],panel)
		styles[options.NUMERAL]=TTextStyleGadget.Create("@@numerals",10,160,options.styles[options.NUMERAL],panel)
		styles[options.ATTRIBUTE]=TTextStyleGadget.Create("@@attributes",10,190,options.styles[options.ATTRIBUTE],panel)

		textarea=CreateTextArea(10,225,ClientWidth(panel)-20,140,panel,TEXTAREA_READONLY)

		Refresh()
	End Method

	Function Create:TOptionsPanel(o:TOptions,host:TGUIContainer)
		Local op:TEditorOptionsPanel

		' create the panel
		op=New TEditorOptionsPanel
		op.options=TEditorOptions(o)

		LanguageSetGroup "options_requester_editor"

		op.InitOptionsPanel("@@title" , host)
		op.InitGUI()

		Return op
	End Function

	Method Show()
		Super.show()
		Refresh()
	End Method

	Method Refresh()
		Local s:TTextStyleGadget

		editstyle.Refresh()
		For s=EachIn styles
			s.Refresh()
		Next

		LockTextArea textarea
		'BUG: the following line is needed to avoid a perplexing bug in blitzmax (if removed, the font can't be changed!)
		SetTextAreaText textarea,""

		SetTextAreaFont textarea,options.editstyle.font
		SetTextAreaColor textarea,options.editstyle.bg.red,options.editstyle.bg.green,options.editstyle.bg.blue,True
		SetTextAreaText textarea,"' Example Listing~nname$=~qBlitzMax~q~nIf a=10 Then~n    Print name$~nEnd If~n~nType TSample {attribute}~nEndType"

		options.styles[options.NORMAL].Format(textarea,0,-1)
		options.styles[options.COMMENT].Format(textarea,0,17)
		options.styles[options.QUOTED].Format(textarea,24,10)
		options.styles[options.KEYWORD].Format(textarea,35,2)
		options.styles[options.NUMERAL].Format(textarea,40,2)
		options.styles[options.KEYWORD].Format(textarea,52,5)
		options.styles[options.KEYWORD].Format(textarea,64,6)
		options.styles[options.KEYWORD].Format(textarea,72,4)
		options.styles[options.ATTRIBUTE].Format(textarea,85,11)
		options.styles[options.KEYWORD].Format(textarea,97,7)

		UnlockTextArea textarea

	End Method

	Method Poll:Int(e:TEvent)
		Local changed:Int = False

		Select e.source

			Default
				Local s:TTextStyleGadget

				If editstyle.Poll() Then changed=True
				For s = EachIn styles
					If s.Poll() Then changed=True
				Next

		End Select

		If changed Then
			Refresh()
			options.setdirty True
'			options.group.dirtyfonts = True
'TODO: reinstate cleverness for dirtyfonts
			Return True
		End If

	End Method
End Type

Type TCodeOptionsPanel Extends TOptionsPanel

	Field options:TCodeOptions

	'gadgets
	Field tabbutton:TGadget
	Field buttons:TGadget[7]

	Method InitGUI()
		' create any specific gadgets here
		buttons[0]=CreateButton("@@syntax_highlighting",10,10,280,24,panel,BUTTON_CHECKBOX)
		buttons[1]=CreateButton("@@auto_capitalise",10,40,280,24,panel,BUTTON_CHECKBOX)
		buttons[2]=CreateButton("@@auto_complete",10,70,280,24,panel,BUTTON_CHECKBOX)
		buttons[6]=CreateButton("@@document_keywords_first",40,100,280,24,panel,BUTTON_CHECKBOX)
		buttons[3]=CreateButton("@@auto_tidy",10,130,280,24,panel,BUTTON_CHECKBOX)
		buttons[4]=CreateButton("@@add_space_before_sep",40,160,280,24,panel,BUTTON_CHECKBOX)
		buttons[5]=CreateButton("@@auto_indent",10,190,280,24,panel,BUTTON_CHECKBOX)
				
		CreateLabel "@@tab_size",10,220,78,28,panel
		tabbutton=CreateComboBox(94,220,48,28,panel)
		For Local i:Int=1 To 8
			AddGadgetItem tabbutton,(i*2)
		Next

		Refresh()
	End Method

	Function Create:TOptionsPanel(o:TOptions,host:TGUIContainer)
		Local op:TCodeOptionsPanel

		' create the panel
		op=New TCodeOptionsPanel
		op.options=TCodeOptions(o)

		LanguageSetGroup "options_requester_code"

		op.InitOptionsPanel("@@title",host)
		op.InitGUI()

		Return op
	End Function

	Method Refresh()
		'tab size
		SetButtonState buttons[0],options.syntaxhighlight
		SetButtonState buttons[1],options.autocapitalize
		SetButtonState buttons[2],options.autocomplete
		SetButtonState buttons[3],options.autotidy
		SetButtonState buttons[4],options.autotidymode & $1
		SetButtonState buttons[5],options.autoindent
		SetButtonState buttons[6],options.dockeysfirst

		SelectGadgetItem tabbutton,Min(Max(options.tabsize/2-1,0),7)

	End Method

	Method Poll:Int(e:TEvent)
		Local changed:Int = False

		Select e.source
			Case buttons[0]
				If e.id = EVENT_GADGETACTION Then options.syntaxhighlight=ButtonState(buttons[0]);changed=True
			Case buttons[1]
				If e.id = EVENT_GADGETACTION Then options.autocapitalize=ButtonState(buttons[1]);changed=True
			Case buttons[2]
				If e.id = EVENT_GADGETACTION Then options.autocomplete=ButtonState(buttons[2]);changed=True
			Case buttons[3]
				If e.id = EVENT_GADGETACTION Then 
					options.autotidy=ButtonState(buttons[3]) ; changed = True
					If options.autotidy Then EnableGadget buttons[4] Else DisableGadget buttons[4]
				EndIf
			Case buttons[4]
				If e.id = EVENT_GADGETACTION Then 
					If ButtonState(buttons[4]) Then
						options.autotidymode:| $1
					Else
						options.autotidymode:& ~$1
					EndIf
					changed = True
				EndIf
			Case buttons[5]
				If e.id = EVENT_GADGETACTION Then options.autoindent=ButtonState(buttons[5]);changed=True
			Case buttons[6]
				If e.id = EVENT_GADGETACTION Then options.dockeysfirst=ButtonState(buttons[6]);changed=True
			Case tabbutton
				If e.id = EVENT_GADGETACTION Then options.tabsize=(e.data+1)*2 ; changed=True

		End Select

		If changed Then
			'Refresh()
			options.setdirty True
			Return True
		End If

	End Method
End Type

Type THostOptionsPanel Extends TOptionsPanel
	Field options:THostOptions
	Field buttons:TGadget[3]
	Field langlist:TGadget

	Method InitGUI()
		'set up the gadgets here!
		buttons[0]=CreateButton("@@show_toolbar",10,10,280,24,panel,BUTTON_CHECKBOX)
		buttons[1]=CreateButton("@@open_files_at_startup",10,40,280,24,panel,BUTTON_CHECKBOX)
		buttons[2]=CreateButton("@@auto_backup",10,70,280,24,panel,BUTTON_CHECKBOX)

		CreateLabel "@@language",10,100,280,24,panel
		langlist = CreateListBox(10, 130, ClientWidth(panel)-20, 100, panel)

		ReloadLangList()

		Refresh()
	End Method

	Function Create:TOptionsPanel(o:TOptions,host:TGUIContainer)
		Local op:THostOptionsPanel

		' create the panel
		op=New THostOptionsPanel
		op.options=THostOptions(o)

		LanguageSetGroup "options_requester_host"

		op.InitOptionsPanel("@@title",host)
		op.InitGUI()

		Return op
	End Function

	Method Refresh()
		SetButtonState buttons[0],options.showtoolbar
		SetButtonState buttons[1],options.restoreopenfiles
		SetButtonState buttons[2],options.autobackup
	End Method

	Method Poll:Int(e:TEvent)
		Local changed:Int = False

		Select e.source
			' deal with events here, and set changed to True if anything, er, changed!
			Case buttons[0]
				If e.id = EVENT_GADGETACTION Then options.showtoolbar=ButtonState(buttons[0]);changed=True

			Case buttons[1]
				If e.id = EVENT_GADGETACTION Then options.restoreopenfiles=ButtonState(buttons[1]);changed=True

			Case buttons[2]
				If e.id = EVENT_GADGETACTION Then options.autobackup=ButtonState(buttons[2]);changed=True

			Case langlist
				If e.id = EVENT_GADGETSELECT Then
					options.languagefile = String(e.extra) ;DebugLog String(e.extra);DebugStop()
					changed = True
				EndIf

		End Select

		If changed Then
			'Refresh()
			options.setdirty True
			Return True
		End If
	End Method

	Method ReloadLangList()
		ClearGadgetItems langlist
		Local file:String[], caption:String[]
		Local index:Int = -1

		' scan appdir
		LanguageEnumFiles AppDir, file, caption
		If file Then
			For Local n:Int = 0 Until file.Length
				index:+1
				AddGadgetItem langlist, caption[n], , , file[n], file[n]
				If file[n] = options.languagefile Then
					SelectGadgetItem langlist, index
				EndIf
			Next
		EndIf

		' scan config dir
		LanguageEnumFiles ExtractDir(options._group._optionsfile), file, caption
		If file Then
			For Local n:Int = 0 Until file.Length
				index:+1
				AddGadgetItem langlist, caption[n], , , file[n], file[n]
				If file[n] = options.languagefile Then
					SelectGadgetItem langlist, index
				EndIf
			Next
		EndIf

		' internal language file
		index:+1
		AddGadgetItem langlist, "  (Default)", , , "", Null
		If options.languagefile = "" Then
			SelectGadgetItem langlist, index
		EndIf

	EndMethod
End Type

Type TBuildOptionsPanel Extends TOptionsPanel
	Field options:TBuildOptions

	Field outputstyle:TGadgetStyleGadget
	Field buttons:TGadget[5]
	Field cmdline:TGadget

	Method InitGUI()
		'set up the gadgets here!
		buttons[0]=CreateButton("@@quick_build",10,10,280,24,panel,BUTTON_CHECKBOX)
		buttons[1]=CreateButton("@@debug_enabled",10,40,280,24,panel,BUTTON_CHECKBOX)
		buttons[2]=CreateButton("@@threaded_build",10,70,280,24,panel,BUTTON_CHECKBOX)		
		CreateLabel "@@command_line",10,100,122,24,panel
		cmdline=CreateTextField(132,100,160,24,panel)
		buttons[3] = CreateButton("@@hide_output_when_complete" , 10 , 130 , 280 , 24 , panel , BUTTON_CHECKBOX)
		buttons[4]=CreateButton("@@output_wordwrap",10,160,280,24,panel,BUTTON_CHECKBOX)
		outputstyle=TGadgetStyleGadget.Create("@@output",10,190,options.outputstyle,panel)

		Refresh()
	End Method

	Function Create:TOptionsPanel(o:TOptions,host:TGUIContainer)
		Local op:TBuildOptionsPanel

		' create the panel
		op=New TBuildOptionsPanel
		op.options=TBuildOptions(o)

		LanguageSetGroup "options_requester_build"

		op.InitOptionsPanel("@@title",host)
		op.InitGUI()

		Return op
	End Function

	Method Refresh()
		outputstyle.Refresh
		SetButtonState buttons[0],options.quickenabled
		SetButtonState buttons[1],options.debugenabled
		SetButtonState buttons[2],options.threadenabled
		SetButtonState buttons[3] , options.hideoutput
		SetButtonState buttons[4],options.wordwrap
		SetGadgetText cmdline,options.cmdline
	End Method

	Method Poll:Int(e:TEvent)
		Local changed:Int = False

		Select e.source
			' deal with events here, and set changed to True if anything, er, changed!
			Case buttons[0]
				If e.id = EVENT_GADGETACTION Then options.quickenabled=ButtonState(buttons[0]); changed=True
			Case buttons[1]
				If e.id = EVENT_GADGETACTION Then options.debugenabled=ButtonState(buttons[1]); changed=True
			Case buttons[2]
				If e.id = EVENT_GADGETACTION Then options.threadenabled=ButtonState(buttons[3]); changed=True				
			Case buttons[3]
				If e.id = EVENT_GADGETACTION Then options.hideoutput=ButtonState(buttons[3]); changed=True
			Case buttons[4]
				If e.id = EVENT_GADGETACTION Then options.wordwrap=ButtonState(buttons[4]); changed=True
			Case cmdline
				If e.id = EVENT_GADGETACTION Then options.cmdline=TextFieldText(cmdline);changed=True
			Default
				If outputstyle.poll() Then changed = True

		End Select

		If changed Then
			'Refresh()
			options.setdirty True
			Return True
		End If
	End Method
End Type


Type TToolsOptionsPanel Extends TOptionsPanel
	Field options:TToolsOptions

	Field buttons:TGadget[4]
	Field navstyle:TGadgetStyleGadget

	Method InitGUI()
		'set up the gadgets here!
		CreateLabel "@@tool_panel_location",10,10,150,28,panel
		buttons[0]=CreateComboBox(166,10,100,28,panel)
		AddGadgetItem buttons[0],"@@right"
		AddGadgetItem buttons[0],"@@left"

		navstyle=TGadgetStyleGadget.Create("@@tool_style",10,40,options.navstyle,panel)
		buttons[3]=CreateButton("@@sort_entries_by_name",10,70,280,24,panel,BUTTON_CHECKBOX)

		Refresh()
	End Method

	Function Create:TToolsOptionsPanel (o:TOptions,host:TGUIContainer)
		Local op:TToolsOptionsPanel

		' create the panel
		op=New TToolsOptionsPanel
		op.options=TToolsOptions(o)

		LanguageSetGroup "options_requester_tools"

		op.InitOptionsPanel("@@title",host)
		op.InitGUI()

		Return op
	End Function

	Method Refresh()
		SelectGadgetItem buttons[0],Min(Max(options.navswap,0),1)
		SetButtonState buttons[3],options.sorted
		navstyle.Refresh
	End Method

	Method Poll:Int(e:TEvent)
		Local changed:Int = False

		Select e.source
			' deal with events here, and set changed to True if anything, er, changed!
			Case buttons[0]
				If e.id = EVENT_GADGETACTION Then options.navswap=SelectedGadgetItem(buttons[0]);changed=True

			Case buttons[3]
				If e.id = EVENT_GADGETACTION Then options.sorted=ButtonState(buttons[3]);changed=True

			Default
				If navstyle.Poll() Then changed=True

		End Select

		If changed Then
			'Refresh()
			options.setdirty True
			Return True
		End If
	End Method
End Type

Type THelpOptionsPanel Extends TOptionsPanel
	Field	options:THelpOptions
	Field	templinks:TGadget
	Field	exthelp:TGadget

	Method InitGUI()
		'set up the gadgets here!
		CreateLabel "@@links_to_code",10,10,105,28,panel
		templinks=CreateComboBox(120,10,200,28,panel)
		AddGadgetItem templinks,"@@open_the_original"
		AddGadgetItem templinks,"@@open_temp_copy"
		exthelp=CreateButton("@@use_external_help_browser",10,40,280,24,panel,BUTTON_CHECKBOX)
		Refresh()
	End Method

	Function Create:TOptionsPanel(o:TOptions,host:TGUIContainer)
		Local op:THelpOptionsPanel

		' create the panel
		op=New THelpOptionsPanel
		op.options=THelpOptions(o)

		LanguageSetGroup "options_requester_help"

		op.InitOptionsPanel("@@title",host)
		op.InitGUI()

		Return op
	End Function

	Method Refresh()
		SelectGadgetItem templinks,options.tempsourcelinks
		SetButtonState exthelp, options.externalhelp
	End Method

	Method Poll:Int(e:TEvent)
		Local changed:Int = False

		Select e.source
			' deal with events here, and set changed to True if anything, er, changed!
			Case templinks
				If e.id = EVENT_GADGETACTION Then options.tempsourcelinks=SelectedGadgetItem(templinks);changed=True
			Case exthelp
				If e.id = EVENT_GADGETACTION Then options.externalhelp=ButtonState(exthelp);changed=True
		End Select

		If changed Then
			'Refresh()
			options.setdirty True
			Return True
		End If
	End Method
End Type

Type TKeyOptionsPanel Extends TOptionsPanel
	Field options:TKeyOptions
	Field _capture:TGadget
	Field _buttons:Tgadget[]
	Field _defbutton:TGadget
	Field _keybutton:Tgadget
	Field _pick:Int=False


	Method InitOptionsPanel(n$ ,host:TGUIContainer) 
		CreateGUIPanel(n$ ,0 , 0 , host.Width(), 1100 , host)	
	End Method
	
	Method InitGUI() 
		Local y:Int = 2
		'set up the gadgets here!
		_capture = CreatePanel(0 , 0 , 5 , 5 , panel , PANEL_ACTIVE) 
		_buttons = New TGadget[options.NUMKEYS+1]
		For Local i:Int = 1 To options.NUMKEYS
			CreateLabel options.keyname(i) , 2 , y , 176 , 28 , panel
			_buttons[i] = CreateButton(options.HotKeyName(i) , 180 , y , 156 , 28 , panel) 
			y:+ 30
		Next
		_keybutton = CreateButton("Press Key Now", 180 , 0 , 106 , 28 , panel)
		_defbutton = CreateButton( "Default" , 290 , 0 , 46 , 28 , panel)
		HideGadget _keybutton
		HideGadget _defbutton
		Refresh()
	End Method

	Function Create:TKeyOptionsPanel (o:TOptions,host:TGUIContainer)
		Local op:TKeyOptionsPanel 

		' create the panel
		op=New TKeyOptionsPanel 
		op.options=TKeyOptions(o)

		LanguageSetGroup "options_requester_keys"

		op.InitOptionsPanel("@@title" , host) 
		Return op
	End Function

	Method Refresh()
	End Method

	Method Show() 
		If _capture = Null Then InitGUI() 
		Super.show() 
	End Method

	Method GetButtonID:Int(g:Object) 
		Local l:Int=_buttons.length 
		For Local i:Int = 0 To l-1
			If g = _buttons[i] Then Return i
		Next
		Return 0
	End Method

	Method Poll:Int(e:TEvent)
		Local changed:Int = False

		' deal with events here, and set changed to True if anything, er, changed!
		' and don't forget to check the eventid!!!
		Local b:Int=GetButtonID(e.source)
		
		If e.source = _capture Then
			If (e.id = EVENT_KEYDOWN Or e.id = EVENT_KEYUP) And _pick Then
				Local k:Int = e.data 
				Local m:Int= e.mods
				If k>=KEY_LSHIFT And k<=KEY_RALT Return False
				If k=KEY_LSYS Or k=KEY_RSYS Return False
				options.Setkey _pick , k , m
				SetGadgetText _buttons[_pick] , options.hotKeyName(_pick)	
				HideGadget _defbutton
				HideGadget _keybutton	
				ShowGadget _buttons[_pick]	
				ActivateGadget panel				
				_pick = 0	
				changed = True
			EndIf
		ElseIf e.source = _defbutton Then
			If e.id = EVENT_GADGETACTION And _pick Then	
				options.SetKeyToDefault _pick
				SetGadgetText _buttons[_pick] , options.hotKeyName(_pick)	
				HideGadget _defbutton
				HideGadget _keybutton	
				ShowGadget _buttons[_pick]			
				ActivateGadget panel				
				_pick = 0	
				changed = True
			EndIf
		ElseIf b<>0	Then	
			If e.id=EVENT_GADGETACTION And _pick=0 Then
				_pick = b
				SetGadgetShape _defbutton , GadgetX(_defbutton) , GadgetY(_buttons[_pick]) , GadgetWidth(_defbutton) , GadgetHeight(_defbutton) 
				SetGadgetShape _keybutton,GadgetX(_keybutton),GadgetY(_buttons[_pick]),GadgetWidth(_keybutton),GadgetHeight(_keybutton)
				ShowGadget _defbutton
				ShowGadget _keybutton
				HideGadget _buttons[_pick]
				ActivateGadget _capture
			EndIf
		ElseIf e.source = _keybutton Then
			If e.id=EVENT_GADGETACTION And _pick Then
				SetGadgetText _buttons[_pick] , options.hotKeyName(_pick)	
				HideGadget _defbutton
				HideGadget _keybutton	
				ShowGadget _buttons[_pick]	
				ActivateGadget _buttons[_pick]
				_pick = 0
				changed=True
			EndIf
		Else
			Return Super.Poll(e) 
		EndIf

		If changed Then
			Refresh()
			options.setdirty 2
			Return True
		End If
	End Method
	
End Type

Rem ' this is a template for creating future option panels
Type TDUMMYOptionsPanel Extends TOptionsPanel
	Field options:T___Options

	Method InitGUI()
		'set up the gadgets here!
		Refresh()
	End Method

	Function Create:TOptionsPanel(o:TOptions,host:TGUIContainer)
		Local op:T___OptionsPanel

		' create the panel
		op=New T___OptionsPanel
		op.options=T___Options(o)

		LanguageSetGroup "options_requester_dummy"

		op.InitOptionsPanel("title",host)
		op.InitGUI()

		Return op
	End Function

	Method Refresh()
	End Method

	Method Poll:Int()
		Local changed:Int = False

		Select EventSource()
			' deal with events here, and set changed to True if anything, er, changed!
			' and don't forget to check the eventid!!!

		End Select

		If changed Then
			Refresh()
			options.setdirty=True
			Return True
		End If
	End Method
End Type
End Rem
