'requesters.bmx
SuperStrict
Import BRL.LinkedList
Import "host.bmx"
Import "style.bmx"
Import "util/miscfuncs.bmx"

'BUG: if you do ctrl-F, type then hit enter, it searches for the old text, not current text

Type TProgressRequester Extends TGUIToolWindow Final
	Field	message$,value:Int
	Field	showing:Int
	Field	label:TGadget
	Field	progbar:TGadget

	Method Poll(e:TEvent)
	End Method

	Method Refresh()
	End Method

	Method Show()	'returns false if cancelled
		showing=True
		Super.Show
	End Method

	Method Hide()
		showing=False
		Super.Hide()
	End Method

	Method Open(title$)
		SetGadgetText _gadget,title
		Show
	End Method

	Method Update(msg$,val:Int)
		If msg$<>message
			message=msg
			If label FreeGadget label
			label=CreateLabel(message,8,8,260,20,_gadget)
		EndIf
		If showing And (val&$fc)<>(value&$fc)	'only update every 4 percent
			UpdateProgBar( progbar,val/100.0 )
			PollSystem
		EndIf
		value=val
	End Method

	Function Create:TProgressRequester(host:TGUIHost)
		Local	progress:TProgressRequester
		progress=New TProgressRequester
		progress.InitToolWindow(host,"ProgressRequester",280,128,1)	'1 for cancel button
		progress.progbar=CreateProgBar( 8,32,260,20,progress.gadget())
		Return progress
	End Function

	Method Invoke:Object(command:Int,argument:Object=Null)
		' there are no invocations relevant to a requester
	End Method

	Method Query:Int(property:Int)
		' there are no properties to query
	End Method

End Type

Type TCmdLineRequester Extends TGUIToolWindow Final
	Field	label:TGadget,textfield:TGadget

	Method Refresh()
	End Method

	Method Poll(e:TEvent)
		Local	id:Int,data:Int
		id=e.id
		data=e.data
		Select e.source
			Case _gadget
				If id=EVENT_WINDOWCLOSE
					Hide
				EndIf
			Case _ok
				If id=EVENT_GADGETACTION Then
					TGUIHost(owner).SetCommandLine TextFieldText(textfield)
					Hide
				EndIf
			Case _cancel
				If id=EVENT_GADGETACTION Then
					SetGadgetText textfield,TGUIHost(owner).GetCommandLine()
					Hide
				EndIf
		End Select
	End Method

	Method Show()
		SetGadgetText textfield,TGUIHost(owner).GetCommandLine()
		Super.Show()
		ActivateGadget textfield
	End Method

	Function Create:TCmdLineRequester(owner:TGUIContainer)
		Local	cmd:TCmdLineRequester
		cmd=New TCmdLineRequester

		LanguageSetGroup "cmd_line_requester"

		cmd.InitToolWindow(owner,"@@title")
		cmd.label=CreateLabel("@@command_line",8,8,260,20,cmd.gadget())
		cmd.textfield=CreateTextField(8,32,260,20,cmd.gadget())
		Return cmd
	End Function

	Method Invoke:Object(command:Int,argument:Object=Null)
		' there are no invocations relevant to a requester
	End Method

	Method Query:Int(property:Int)
		' there are no properties to query
	End Method

End Type

Type TGotoRequester Extends TGUIToolWindow Final
	Field	_linenumber:TGadget
	Field	_editor:TGUIEditor

	Method InitMe()
		CreateLabel("@@line_number",20,24,114,16,_gadget)
		_linenumber = CreateTextField(134 , 20 , 100 , 24 , _gadget )
	End Method

	Method Refresh()
	End Method

	Method SetTarget(target:Object)
		_editor=TGUIEditor(target)
	End Method

	Method Show()
		If _editor=Null Then RuntimeError "OOPS!"
		Super.Show()
		ActivateGadget _linenumber
	End Method

	Method Invoke:Object(command:Int,argument:Object=Null)
		' there are no invocations relevant to a requester
	End Method

	Method Query:Int(property:Int)
		' there are no properties to query
	End Method

	Method Poll(e:TEvent)
		Local	line:Int,data:Int
		Select e.source
			Case _gadget
				If e.id=EVENT_WINDOWCLOSE
					Hide
				EndIf
			Case _ok
				If e.id=EVENT_GADGETACTION Then
					line=Int(TextFieldText(_linenumber))
					Hide
					_editor.Invoke TOOLGOTO , String(line)
				EndIf
			Case _cancel
				If e.id=EVENT_GADGETACTION Then Hide
		End Select
	End Method

	Function Create:TGotoRequester(host:TGUIHost)
		Local	seek:TGotoRequester
		seek=New TGotoRequester

		LanguageSetGroup "goto_requester"

		seek.InitToolWindow(host , "@@title" , 260 , 128)
		seek.InitMe()

		Return seek
	End Function
End Type

Type TSearchRequester Extends TGUIToolWindow Final
	Field	findbox:TGadget,typebox:TGadget,pathbox:TGadget,pathbutton:TGadget

	Method Refresh()
	End Method

	Method Poll(e:TEvent)
		Select e.source
			Case _gadget
				If e.id=EVENT_WINDOWCLOSE
					Hide
				EndIf
			Case _ok
				If e.id=EVENT_GADGETACTION Then Hide
			Case _cancel
				If e.id=EVENT_GADGETACTION Then Hide
		End Select
	End Method

	Method Invoke:Object(command:Int,argument:Object=Null)
		' there are no invocations relevant to a requester
	End Method

	Method Query:Int(property:Int)
		' there are no properties to query
	End Method

	Function Create:TSearchRequester(host:TGUIHost)
		Local	search:TSearchRequester
		Local win:TGadget

		search=New TSearchRequester

		LanguageSetGroup "search_requester"

		search.InitToolWindow(host , "Find In Files" , 400 , 256)
		win=search.gadget()

		CreateLabel("Find What",6,18,80,24,win)
		search.findbox=CreateTextField(88,14,180,20,win)

		CreateLabel("File Types",6,48,80,24,win)
		search.typebox=CreateTextField(88,44,180,20,win)

		CreateLabel("Search Path",6,78,80,24,win)
		search.pathbox=CreateTextField(88,74,180,20,win)

		Return search
	End Function
End Type

'
' New unified Find/Replace dialog
'
'TODO: finish me!
Type TFindReplaceRequester Extends TGUIToolWindow Final
	' find
	Field	_findterm:TGadget, _findnext:TGadget
	' replace
	Field 	_replaceterm:TGadget, _replaceit:TGadget
	Field	_replaceall:TGadget, _replacesel:TGadget
	Field	_replacecount:TGadget
	' options
	Field	_matchwords:TGadget
	Field	_matchcase:TGadget
	Field	_regexp:TGadget
	Field	_wraparound:TGadget
	Field	_icomments:TGadget
	Field	_istrings:TGadget
	' other
	Field	_close:TGadget
	Field	_editor:TGUIEditor
	' find / replace history
	Field	FindHistory:TList = New TList
	Field 	ReplaceHistory:TList = New TList
	Field 	ReplaceCounter:Int

	Method InitMe()
		Local x:Int , y:Int, w:Int

		' search field
		w = ClientWidth(_gadget) - (134 - 16)
		y = 14
		CreateLabel( "@@find_what", 8,y+4, 98,24, _gadget )
		_findterm = CreateComboBox( 106,y, w,28, _gadget, COMBOBOX_EDITABLE)
		'TODO: wait for BRL to implement FilterKeys for ComboBoxes ;)
		'SetGadgetFilter _findterm, FindTerm_FilterKey, Self

		' replace field
		y :+ 32
		CreateLabel( "@@replace_with", 8,y+4, 98,24, _gadget)
		_replaceterm = CreateComboBox( 106,y, w,28, _gadget, COMBOBOX_EDITABLE)
		'TODO: wait for BRL to implement FilterKeys for ComboBoxes ;)
		'SetGadgetFilter _findterm, ReplaceTerm_FilterKey, Self

		' control buttons
		x = ClientWidth(_gadget) - (150 + 8)
		y :+ 32
		_findnext = CreateButton( "@@find_next", x,y, 150,28, _gadget,BUTTON_OK)
		_replaceit = CreateButton( "@@replace", x,y+32, 150,28, _gadget)
		_replaceall = CreateButton( "@@replace_all", x,y+64, 150,28, _gadget)
		_replacesel = CreateButton( "@@replace_in_selection", x,y+96, 150,28, _gadget)
		_close = CreateButton("@@close",x,y+128,150,34,_gadget,BUTTON_CANCEL)

		' replace counter
		CreateLabel( "@@replace_count",x,y+160, 110,24, _gadget)
		_replacecount = CreateLabel( "0", x+110,y+160, 24,24, _gadget)

		' find / replace settings
		y = 14 + 64
		_matchwords = CreateButton( "@@match_whole_word", 8,y, 200,24, _gadget, BUTTON_CHECKBOX) ; y:+30
		_matchcase = CreateButton( "@@match_case", 8,y, 200,24, _gadget, BUTTON_CHECKBOX) ; y:+30
		_regexp = CreateButton( "@@regular_expression", 8,y, 200,24, _gadget, BUTTON_CHECKBOX) ; y:+30
		_wraparound = CreateButton( "@@wrap_around", 8,y, 200,24, _gadget, BUTTON_CHECKBOX) ; y:+30
		_icomments = CreateButton( "@@ignore_comments", 8,y, 200,24, _gadget, BUTTON_CHECKBOX) ; y:+30
		_istrings = CreateButton( "@@ignore_strings", 8,y, 200,24, _gadget, BUTTON_CHECKBOX) ; y:+30

		'not implemented
		DisableGadget _regexp
		DisableGadget _istrings

		' set default options
		SetButtonState _wraparound, True
	EndMethod

	Rem
	Function FindTerm_FilterKey:Int( event:TEvent, context:Object)
		If (event.ID = EVENT_KEYDOWN) And (event.Data = KEY_RETURN) Then
			TFindReplaceRequester(context).FindNext()
			Return False
		EndIf
		Return True
	EndFunction

	Function ReplaceTerm_FilterKey:Int( event:TEvent, context:Object)
		If (event.ID = EVENT_KEYDOWN) And (event.Data = KEY_RETURN) Then
			TFindReplaceRequester(context).ReplaceIt()
			Return False
		EndIf
		Return True
	EndFunction
	EndRem

	Method SetTarget(target:Object)
		_editor=TGUIEditor(target)
	EndMethod

	Method Show()
		If _editor=Null Then
			Notify "No document selected"
			Return
		EndIf
		Super.Show()
		ActivateGadget _findterm
	EndMethod

	Method ShowFind(term$ = "")
		If _editor=Null Then
			Notify "No document selected"
			Return
		EndIf
		If term.Length > 0 Then SetGadgetText( _findterm,term)
		Super.Show()
		ActivateGadget _findterm
	EndMethod

	Method Poll(e:TEvent)
		Local	find:String,rep:String
		Select e.Source
			Case _gadget
				If e.id=EVENT_WINDOWCLOSE Then Hide
				
			Case _close
				If e.id=EVENT_GADGETACTION Then Hide;ReplaceCounter = 0
				
			Case _findnext
				If e.id=EVENT_GADGETACTION Then FindNext()
				
			Case _replaceit
				If e.id=EVENT_GADGETACTION Then ReplaceIt()

			Case _replaceall
				If e.id=EVENT_GADGETACTION Then
					ReplaceCounter = 0
					find = TextFieldText( _findterm)
					rep = TextFieldText( _replaceterm)
					SelectHistory( AddHistory( find))
					SelectHistory( AddHistory( rep, ReplaceHistory), ReplaceHistory)
					ReplaceCounter = _editor.Invoke( TOOLREPLACEALL, find + Chr(0) + rep).ToString().ToInt()
				EndIf
				
			Case _replacesel
				If e.id=EVENT_GADGETACTION Then
					ReplaceCounter = 0
					find = TextFieldText(_findterm)
					rep = TextFieldText(_replaceterm)
					SelectHistory(AddHistory(find))
					SelectHistory(AddHistory(rep, ReplaceHistory), ReplaceHistory)
					ReplaceCounter = _editor.Invoke(TOOLREPLACEALLINSELECTION , find + Chr(0) + rep).ToString().ToInt()
				EndIf
		EndSelect
		Refresh()
	EndMethod

	Function Create:TFindReplaceRequester(host:TGUIHost)
		Local	seek:TFindReplaceRequester
		seek=New TFindReplaceRequester

		LanguageSetGroup "find_replace_requester"

		seek.InitToolWindow(host , "@@title" , 420, 270, TOOLWINDOW_MODAL| TOOLWINDOW_CENTER)
		seek.InitMe()

		Return seek
	EndFunction

'MARK: find & replace methods
	Method FindNext()
		Local find:String = TextFieldText( _findterm)
		DebugLog TextFieldText(_findterm)
		ReplaceCounter = 0
		SelectHistory( AddHistory( find))
		_editor.Invoke(TOOLFINDNEXT, find)
	EndMethod

	Method ReplaceIt()
		Local find:String = TextFieldText( _findterm)
		Local rep:String = TextFieldText( _replaceterm)
		SelectHistory( AddHistory( find))
		SelectHistory( AddHistory( rep, ReplaceHistory), ReplaceHistory)
		If _editor.Query( QUERY_HASSELECTION) Then
			' replace currently selected text
			If _editor.Invoke( TOOLREPLACE, rep) Then
				ReplaceCounter :+ 1
				_editor.Invoke( TOOLFINDNEXT, find)
			EndIf
		Else
			' find next & replace
			ReplaceCounter = 0
			If _editor.Invoke( TOOLFINDNEXT, find) Then
				If _editor.Invoke( TOOLREPLACE, rep)
					ReplaceCounter :+ 1
					_editor.Invoke( TOOLFINDNEXT, find)
				EndIf
			EndIf
		EndIf
	EndMethod

'MARK: history methods
	Method AddHistory:Int( term:String, history:TList=Null)
		If Not history Then history = FindHistory
		If SearchHistory( term, history) = -1 Then
			history.AddLast( term)
			Select history
				Case FindHistory		AddGadgetItem _findterm, term
				Case ReplaceHistory	AddGadgetItem _replaceterm, term
			EndSelect
			Return history.Count() - 1
		EndIf
		Return -1
	EndMethod

	Method SearchHistory:Int( term:String, history:TList=Null)
		If Not history Then history = FindHistory
		If term.Length <= 0 Then Return -1
		Local index:Int = 0
		For Local s:String = EachIn FindHistory
			If s = term Then Return index
			index :+ 1
		Next
		Return -1
	EndMethod

	Method SelectHistory( index:Int, history:TList=Null)
		If Not history Then history = FindHistory
		If (index >= 0) And (index < history.Count()) Then
			Select history
				Case FindHistory		SelectGadgetItem _findterm, index
				Case ReplaceHistory	SelectGadgetItem _replaceterm, index
			EndSelect
		EndIf
	EndMethod

	Method ClearHistory( history:TList=Null)
		If Not history Then history = FindHistory
		history.Clear()
		Select history
			Case FindHistory
				ClearGadgetItems _findterm
				SelectGadgetItem _findterm, 0
			Case ReplaceHistory
				ClearGadgetItems _replaceterm
				SelectGadgetItem _replaceterm, 0
		EndSelect
	EndMethod

	Method Refresh()
		' update replace counter
		SetGadgetText _replacecount, String.FromInt( ReplaceCounter)
	EndMethod

' not used
	Method Invoke:Object(command:Int,argument:Object=Null)
	EndMethod

	Method Query:Int(property:Int)
	EndMethod
EndType

