
Import PUB.Win32

SuperStrict

?Win32
Private
Global Mutex:Int
Public

OnEnd ReleaseInstance

Function ReleaseInstance()
	Extern "Win32"
		Function ReleaseMutex:Int( mutex:Int)
	EndExtern
	
	If Mutex Then
		ReleaseMutex( Mutex)
		Mutex = 0
	EndIf
EndFunction
?

Function InitSingleInstance:Int( name:String)
?Win32
	Extern "Win32"
		Const ERROR_ALREADY_EXISTS:Int = 183
		
		Function CreateMutexW:Int( security:Byte Ptr, owner:Int, name$w)
		Function GetLastError:Int()
	EndExtern
	
	Mutex = CreateMutexW( Null, True, name)
	If (Not Mutex) Or (GetLastError() = ERROR_ALREADY_EXISTS) Then Return False
?
	Return True
EndFunction

Function SendOpenFileMessage:Int( classname:String, title:String, fn:String[])
?Win32
	Const DROPFILES_SIZE:Int = 16
	
	Extern "Win32"
		Const GHND:Int = 32
		Const GMEM_SHARE:Int = 8192
		
		Function EnumWindows:Int( enumproc:Byte Ptr, lparam:Byte Ptr)
		Function GetWindowModuleFileNameW:Int( hwnd:Int, buffer:Short Ptr, sz:Int)
		Function GetModuleFileNameW:Int( hmodule:Int, buffer:Short Ptr, sz:Int)			
	EndExtern
	
	' this function checks each window and compares CLASSNAME & partial WINDOWTITLE
	Function EnumProc:Int( hwnd:Int, lparam:Int Ptr)
		Extern "Win32"
			Function GetWindowTextW:Int( hwnd:Int, dst:Short Ptr, maxlen:Int)
			Function GetClassNameW:Int( hwnd:Int, dst:Short Ptr, maxlen:Int)
		EndExtern
	
		Local buf:Short[512]
		
		GetClassNameW( hwnd, buf, buf.Length)
		If String.FromWString(buf) = String.FromWString(Short Ptr lparam[0]) Then
			GetWindowTextW( hwnd, buf, buf.Length)
			If String.FromWString(buf).StartsWith( String.FromWString(Short Ptr lparam[1])) Then
				lparam[2] = hwnd
				Return False
			EndIf
		EndIf
		Return True
	EndFunction
	
	' enumerate over all windows and find the one we want
	Local enumdata:Int[3]
	enumdata[0] = Int classname.ToWString()
	enumdata[1] = Int title.ToWString()
	EnumWindows( EnumProc, enumdata)
	MemFree Byte Ptr enumdata[0]
	MemFree Byte Ptr enumdata[1]
	
	If Not enumdata[2] Then Return False
	Local hwnd:Int = enumdata[2]
	
	' check that the executables are the same
	Local buf:Short[512], myexe:String, otherexe:String
	GetModuleFileNameW( 0, buf, buf.Length)
	myexe = String.FromWString(buf)
	GetWindowModuleFileNameW( hwnd, buf, buf.Length)
	otherexe = String.FromWString(buf)
	If myexe <> otherexe Then Return False
	
	' activate and show the window
	SetForegroundWindow( hwnd)
	If IsIconic(hwnd) Then ShowWindow( hwnd, SW_RESTORE)
	
	' send file drop message
	If fn Then
		' get size of all filenames
		Local fsz:Int
		For Local s:String = EachIn fn
			fsz :+ s.Length + 1
		Next
		' create HDROP data
		Local sz:Int = DROPFILES_SIZE + fsz + 1
		Local hdrop:Int = GlobalAlloc( GHND | GMEM_SHARE, sz)
		Local p:Byte Ptr = GlobalLock(hdrop)
		If Not p Then
			GlobalFree(hdrop)
			Return False
		EndIf
		MemClear p, sz
		Int Ptr(p)[0] = DROPFILES_SIZE
		' copy all filenames to HDROP data
		p :+ DROPFILES_SIZE
		For Local s:String = EachIn fn
			Local cstr:Byte Ptr = s.ToCString()
			MemCopy p, cstr, s.Length
			MemFree cstr
			p :+ s.Length + 1
		Next
		GlobalUnlock(hdrop)
		
		' send message
		PostMessageA( hwnd, WM_DROPFILES, hdrop, 0)
		GlobalFree(hdrop)
	EndIf
?
	Return True
EndFunction
