'stylegadgets.bmx

SuperStrict

Import "tool.bmx"
Import "style.bmx"

' Custom gadgets to set these styles

Type TTextStyleGadget
	Field	panel:TGadget,combo:TGadget
	Field	textstyle:TTextStyle

	Method Poll:Int()
		Select EventSource()
			Case panel
				If EventID()=EVENT_MOUSEDOWN
					textstyle.color.Request() 
					Refresh() 
					Return True
				EndIf
			Case combo
				If EventID() = EVENT_GADGETACTION Then 
					textstyle.flags = SelectedGadgetItem(combo) 
					Refresh()
					Return True
				EndIf
		End Select
	End Method

	Method Refresh()
		SetPanelColor panel,textstyle.color.red,textstyle.color.green,textstyle.color.blue
		SelectGadgetItem combo,textstyle.flags
	End Method

	Function Create:TTextStyleGadget(name$,xpos:Int,ypos:Int,textstyle:TTextStyle,window:TGadget)
		Local	s:TTextStyleGadget
		s=New TTextStyleGadget
		If textstyle=Null Then
			s.textstyle=TTextStyle.Create()
		Else
			s.textstyle=textstyle
		EndIf
		CreateLabel(name,xpos,ypos,80,28,window)
		s.panel=CreatePanel(xpos+84,ypos,28,28,window,PANEL_BORDER|PANEL_ACTIVE)
		SetPanelColor s.panel,textstyle.color.red,textstyle.color.green,textstyle.color.blue
		s.combo=CreateComboBox(xpos+116,ypos,150,28,window)
		AddGadgetItem s.combo,"@@text_style/normal"
		AddGadgetItem s.combo,"@@text_style/bold"
		AddGadgetItem s.combo,"@@text_style/italic"
		AddGadgetItem s.combo,"@@text_style/bold_italic"
		Return s
	End Function

End Type

Type TGadgetStyleGadget
	Field	fpanel:TGadget,bpanel:TGadget,fbutton:TGadget
	Field	gadgetstyle:TGadgetStyle

	Method Poll:Int()
		Local	f:TGUIFont
		Select EventSource()
			Case fpanel
				If EventID()=EVENT_MOUSEDOWN
					gadgetstyle.fg.Request()
					Refresh()
					Return True
				EndIf
			Case bpanel
				If EventID()=EVENT_MOUSEDOWN
					gadgetstyle.bg.Request() 
					Refresh()
					Return True					
				EndIf
			Case fbutton
				If EventID() = EVENT_GADGETACTION Then 
					f=RequestFont(gadgetstyle.font)
					If f
						gadgetstyle.font_name=FontName(f)
						gadgetstyle.font_size=FontSize(f)
						gadgetstyle.font=f
						Refresh()
						Return True
					EndIf
				EndIf
		End Select
	End Method

	Method Refresh()
		If fpanel Then SetPanelColor fpanel,gadgetstyle.fg.red,gadgetstyle.fg.green,gadgetstyle.fg.blue
		If bpanel Then SetPanelColor bpanel,gadgetstyle.bg.red,gadgetstyle.bg.green,gadgetstyle.bg.blue
		If fbutton Then SetGadgetText fbutton,gadgetstyle.font_name+":"+gadgetstyle.font_size
	End Method

	Const FOREGROUND:Int=1
	Const BACKGROUND:Int=2
	Const FONT:Int=4

	Function Create:TGadgetStyleGadget(name$,xpos:Int,ypos:Int,gadgetstyle:TGadgetStyle,window:TGadget,flags:Int=FOREGROUND|BACKGROUND|FONT)
		Local	s:TGadgetStyleGadget
		Local	x:Int

		s=New TGadgetStyleGadget
		If gadgetstyle=Null Then
			s.gadgetstyle=TGadgetStyle.Create()
		Else
			s.gadgetstyle=gadgetstyle
		End If

		CreateLabel(name,xpos,ypos,80,28,window)
		x=xpos+84
		If flags & FOREGROUND Then
			s.fpanel=CreatePanel(x,ypos,28,28,window,PANEL_BORDER|PANEL_ACTIVE)
			x=x+32
		EndIf
		If flags & BACKGROUND Then
			s.bpanel=CreatePanel(x,ypos,28,28,window,PANEL_BORDER|PANEL_ACTIVE)
			x=x+32
		EndIf
		If flags & FONT
			s.fbutton=CreateButton("..",x,ypos,350-x,28,window)
		End If
		Return s
	End Function

End Type
