' tool.bmx
'
' this file contains the abstract types used as a basis for all
' "tool" windows, such as the code editor, help and output panels.

SuperStrict

Import "locale/language.bmx" ' to override the BRL.MaxGUI functions in every file
Import BRL.Reflection

' TOOL constants relating to commands that can be invoked on any tool
Const TOOLRESET:Int=	0
Const TOOLSHOW:Int=		1
Const TOOLREFRESH:Int=	2
Const TOOLNEW:Int=		3
Const TOOLOPEN:Int=		4
Const TOOLCLOSE:Int=	5
Const TOOLSAVE:Int=		6
Const TOOLHELP:Int=		7
Const TOOLUNDO:Int=		8
Const TOOLREDO:Int=		9
Const TOOLCUT:Int=		10
Const TOOLCOPY:Int=		11
Const TOOLPASTE:Int=	12
Const TOOLQUICKSAVE:Int=13
Const TOOLSAVEAS:Int=	14
Const TOOLGOTO:Int=		15
Const TOOLFINDREPLACE:Int=		16
Const TOOLFINDNEXT:Int=	17
Const TOOLREPLACE:Int=	18
Const TOOLBUILD:Int=	19
Const TOOLRUN:Int=		20
Const TOOLLOCK:Int=	21
Const TOOLUNLOCK:Int=	22
Const TOOLSELECT:Int=	23
Const TOOLSELECTALL:Int=24
Const TOOLINDENT:Int=	25
Const TOOLOUTDENT:Int=	26
Const TOOLACTIVATE:Int=	27
Const TOOLNAVIGATE:Int=	28	' show a particular file or item
'Const TOOLNEWVIEW:Int=	29
Const TOOLMENU:Int=		30
Const TOOLPRINT:Int=	31
Const TOOLAUTOCOMPLETE:Int = 32
Const TOOLCOMMENT:Int=	33
Const TOOLUNCOMMENT:Int=34
Const TOOLBACK:Int=		35
Const TOOLFORWARD:Int=	36
Const TOOLTOGGLEMARK:Int=37
Const TOOLNEXTMARK:Int=	38
Const TOOLPREVIOUSMARK:Int=39

Const TOOLDEBUG:Int = 40
Const TOOLREPLACEALL:Int = 	41

Const TOOLERROR:Int=42
Const TOOLOUTPUT:Int = 43
Const TOOLEXECUTE:Int = 44

Const TOOLPROPERTIES:Int = 45
Const TOOLUPDATE:Int = 46
Const TOOLCOMMIT:Int = 47
Const TOOLBROWSE:Int = 48
Const TOOLSHELL:Int=49

Const TOOLPARSEERROR:Int=50


Const TOOLREPLACEALLINSELECTION:Int = 56 '<<< last value

Const TOOLNEXTFILE:Int = 60
Const TOOLPREVFILE:Int = 61

Const TOOLTYPENAME:Int=999

' Query constants
Const QUERY_ISDIRTY:Int = 1
Const QUERY_HASSELECTION:Int = 2 ' returns True if editor has selection
Const QUERY_NAME:Int = 3

' menu constants
Const MENUNEW:Int=1
Const MENUOPEN:Int=2
Const MENUCLOSE:Int=3
Const MENUCLOSEALL:Int = 55
Const MENUSAVE:Int=4
Const MENUSAVEAS:Int=5
Const MENUSAVEALL:Int=6
Const MENUPRINT:Int=7
Const MENUQUIT:Int=8

Const MENUUNDO:Int=9
Const MENUREDO:Int=10
Const MENUCUT:Int=11
Const MENUCOPY:Int=12
Const MENUPASTE:Int=13
Const MENUSELECTALL:Int=14
Const MENUGOTO:Int=15
Const MENUINDENT:Int=16
Const MENUOUTDENT:Int=17
Const MENUFINDREPLACE:Int=18
Const MENUFINDNEXT:Int=19
'TODO: marked for removal
'Const MENUNEXT:Int=21
'Const MENUPREV:Int=22
Const MENUBUILD:Int=23
Const MENURUN:Int=24

Const MENUSTEP:Int=25
Const MENUSTEPIN:Int=26
Const MENUSTEPOUT:Int=27
Const MENUSTOP:Int=28

Const MENULOCKBUILD:Int=29
Const MENUUNLOCKBUILD:Int=30
Const MENUBUILDMODULES:Int=31
Const MENUBUILDALLMODULES:Int=32

Const MENUQUICKENABLED:Int=33
Const MENUDEBUGENABLED:Int=34

Const MENUCOMMANDLINE:Int=36
Const MENUSYNCMODS:Int=37
Const MENUIMPORTBB:Int=38
Const MENUFINDINFILES:Int=39
Const MENUPROJECTMANAGER:Int=40
Const MENUSHOWCONSOLE:Int=41
Const MENUOPTIONS:Int=42

Const MENUHOME:Int=43
'TODO: marked for removal
'Const MENUBACK:Int=44
'Const MENUFORWARD:Int=45
Const MENUQUICKHELP:Int=46
Const MENUABOUT:Int=47

'Const MENUNEWVIEW:Int=48 ' redundant
Const MENUDOCMODS:Int = 49

Const MENUCOMMENT:Int=50
Const MENUUNCOMMENT:Int=51

Const MENUTOGGLEMARK:Int=52
Const MENUNEXTMARK:Int=53
Const MENUPREVIOUSMARK:Int=54

'Const MENUCLOSEALL:Int = 55 ' Defined above
Const MENUIMPORTMOD:Int = 56
Const MENUEXPORTMOD:Int = 57

Const MENUDEBUG:Int = 58

Const MENUTRIGGERDOCMODS:Int=59
Const MENUTRIGGERSYNCDOCS:Int=60

Const MENUREFRESH:Int=61
Const MENUBROWSE:Int=62
Const MENUSHELL:Int = 63

Const MENUPROPS:Int=64
Const MENUUPDATE:Int=65
Const MENUCOMMIT:Int=66

Const MENUNEXTFILE:Int = 70
Const MENUPREVFILE:Int = 71

Const MENUTHREADENABLED:Int = 72

Const MENUAPPCONSOLE:Int = 73
Const MENUAPPGUI:Int = 74
Const MENUAPPWXGUI:Int = 75

Const MENUTARGETWIN:Int = 76
Const MENUTARGETLINUX:Int = 77
Const MENUTARGETMACOS:Int = 78
Const MENUTARGETMACOSUNI:Int = 79

Const MENURECENT:Int = 256



Function TranslateMenuToTool:Int(menucmd:Int) 
	'TODO: this all seems rather silly, creating menus with one command set, only to translate it all.  Find a better way!
	Select menucmd
		Case MENUCUT 		Return TOOLCUT
		Case MENUCOPY		Return TOOLCOPY
		Case MENUPASTE		Return TOOLPASTE
		Case MENUSELECTALL	Return TOOLSELECTALL
		Case MENUINDENT		Return TOOLINDENT
		Case MENUOUTDENT	Return TOOLOUTDENT
		Case MENUCOMMENT	Return TOOLCOMMENT
		Case MENUUNCOMMENT	Return TOOLUNCOMMENT
		Case MENUFINDREPLACE	Return TOOLFINDREPLACE
		Case MENUFINDNEXT		Return TOOLFINDNEXT
		Case MENUGOTO		Return TOOLGOTO
		Case MENUTOGGLEMARK	Return TOOLTOGGLEMARK
		Case MENUPREVIOUSMARK	Return TOOLPREVIOUSMARK
		Case MENUNEXTMARK	Return TOOLNEXTMARK	
		Case MENUPROPS		Return TOOLPROPERTIES	
		Case MENUUPDATE		Return TOOLUPDATE
		Case MENUCOMMIT		Return TOOLCOMMIT
		Case MENUREFRESH	Return TOOLREFRESH
		Case MENUBROWSE		Return TOOLBROWSE
		Case MENUSHELL		Return TOOLSHELL
		Case MENUNEXTFILE	Return TOOLNEXTFILE
		Case MENUPREVFILE	Return TOOLPREVFILE
		Default				RuntimeError "Failed to translate menu to tool command!"
	End Select
End Function

Type TBase Abstract
' the base building block of all the IDE elements is a TBase, which has a series of
' commands that can be invoked
	Method Invoke:Object(command:Int , argument:Object = Null) Abstract
		' note that if you find yourself needing to pass in, or return an Integer, you will
		' need to convert it to a String and back again, as Int is not an Object.
		' I believe marksibly has some long-term plans to make all datatypes, including
		' Int, an Object, so this hack may become redundant in the future.

	Method Query:Int(property:Int) Abstract

' following lines are useful when debugging creation / deletion of object for memory leaks
	Field _typename$
?debug
	Global uniqueseq:Long
	Field uniqueid:Long 

	Method New() 
		uniqueseq:+ 1
		uniqueid = uniqueseq
		Local id:TTypeId=TTypeId.ForObject( Self )
		'DebugLog "Create Type : " + uniqueid + " : " + _typename
	End Method

	Method Delete()
		'DebugLog "Destroyed Type : " + uniqueid + " : " + _typename
	End Method
?
End Type

Type TGUIElement Extends TBase Abstract
' A TGUIElement is an object that provides a GUI, and therefore
' should expect to process some events.  This is done through
' calling Poll(), with the code behind this function expected to
' use EventID(), EventSource() etc to discern whether the event
' is relevant or not, and do whatever it needs to.
	Method Poll(e:TEvent) Abstract
	Method Refresh() Abstract
	Method Hide() Abstract
	Method Show() Abstract ' for making the gui element visible, not showing a particular item.
	Method Gadget:TGadget() Abstract
End Type

Type TGUIPanel Extends TGUIElement Abstract
' A TPanel is a GUI element that provides functionality to the user as an
' element of a larger screen (as opposed to an entire window)
	Field	name$
	Field	panel:TGadget
	Field	index:Int
	Field 	active:Int
	'TODO: not convinced the active flag, or activepanel on the THost, are needed
	Field _vscrollbar:TGadget

	Method	Hide()
		HideGadget panel
		If _vscrollbar Then HideGadget _vscrollbar		
	End Method

	Method Show()
		'DebugLog "--> TGUIPanel.Show()"
		ShowGadget panel
		If _vscrollbar Then ShowGadget _vscrollbar		
	End Method

	Method Enable()
		EnableGadget panel
		If _vscrollbar Then EnableGadget _vscrollbar
	End Method
	
	Method Disable()
		DisableGadget panel
		If _vscrollbar Then DisableGadget _vscrollbar
	End Method

	Method CreateGUIPanel(n$ , x:Int , y:Int , w:Int , h:Int , host:TGUIContainer = Null)
		Local clientgadget:TGadget = host.gadget()
		Local cw:Int = ClientWidth(clientgadget ) 
		Local ch:Int = ClientHeight(clientgadget) 
		
		name$ = n$
		panel=CreatePanel(x,y,w,h,clientgadget)
		SetGadgetLayout panel , 1 , 1 , 1 , 1
		
		If w > cw Then Throw "TGUIPanel.CreateGUIPanel: Over-sized panels and horizontal scrollers not yet supported."
		'TODO: consider supporting panels that slide left/right
		If h > ch Then ' we have a vertically scrolling panel
			_vscrollbar = CreateSlider(cw - 18 , 0 , 18 , ch , clientgadget , SLIDER_SCROLLBAR | SLIDER_VERTICAL) 
			SetSliderRange _vscrollbar , ch , h
			SetGadgetShape panel , GadgetX(panel) , 0 , ClientWidth(panel)-18 , ClientHeight(panel)			
		EndIf

		HideGadget panel
		If _vscrollbar Then HideGadget _vscrollbar
				
	End Method

	Method Gadget:TGadget()
		Return panel
		'TODO: should be _panel (or even _gadget?)
	End Method
	
	Method Poll(e:TEvent)
		'only relevant if it's a scroller
		If e.source = _vscrollbar
			If e.id=EVENT_GADGETACTION 
				Local sy:Int = SliderValue(_vscrollbar) 
				SetGadgetShape panel,GadgetX(panel),-sy,GadgetWidth(panel),GadgetHeight(panel)
			EndIf
		EndIf
		
	End Method	

End Type

Type TGUIEditor Extends TGUIPanel Abstract
	Field	path$
	'Field	filename$ - may be needed?
End Type

Type TGUINavigator Extends TGUIPanel Abstract
	Field _target:TGUIPanelGroup

	Method ShowPanel:Int(panel:TGUIPanel)
		If _target.ShowPanel(panel) Then
			'ensure the navigator highlights the relevant item (tab, treenode, listitem, etc)
'			Return ShowItemForPanel(panel)
		End If
		Return False
	End Method

'TODO: ShowItemForPanel
'	Method ShowItemForPanel:Int(panel:TGUIPanel) Abstract
		' this method should ensure that the correct item in the navigator is shown for
		' the passed in panel.

	'Method Initialize(parent:TGUIContainer,target:TGUIPanelGroup) Abstract

	Method AddNavigation(name$ , target:TGUIPanel, icon:Int) Abstract
	Method SetNavigation(index:Int) Abstract

End Type

Type TGUIContainer Extends TGUIElement Abstract
	Field owner:TGUIContainer 	' the window that owns this container
	Field _gadget:TGadget 		' the window (or panel) that constitutes the basis of this container

	Method Hide()
		HideGadget _gadget
	End Method

	Method Show()
		ShowGadget _gadget
	End Method

	Method Enable()
		EnableGadget _gadget
	End Method
	
	Method Disable()
		DisableGadget _gadget
	End Method
	
	Method Activate()
		ActivateGadget _gadget
	End Method

	Method Width:Int()
		Return ClientWidth(_gadget)
	End Method

	Method Height:Int()
		Return ClientHeight(_gadget)
	End Method

	Method Gadget:TGadget()
		Return _gadget
	End Method
	
	Method Free() ' use this for windows that you are happy to create / destroy as needed
		Hide()
		FreeGadget _gadget
	End Method	

End Type

Type TGUINavTabber Extends TGUINavigator Final
	Field	_tabber:TGadget

	Method Initialize(parent:TGUIContainer , target:TGUIPanelGroup , is:TIconStrip=Null)
		_target=target
		_tabber = CreateTabber(4 , 4 , parent.Width() - 8 , parent.Height() - 48 , parent.gadget() ) 
		If is Then SetGadgetIconStrip _tabber , is
		SetGadgetLayout _tabber , 1 , 1 , 1 , 1
	End Method

	Method AddNavigation(name$,navtarget:TGUIPanel,icon:Int=-1)
		AddGadgetItem _tabber , name,0,icon,name,navtarget
	End Method

	Method SetNavigation(index:Int)
		SelectGadgetItem _tabber,index
	End Method

	Method Invoke:Object(command:Int , argument:Object = Null)
		'nothing much makes sense here
	End Method

	Method Query:Int(property:Int)
		'nothing much makes sense here
	End Method

	Method Poll:Int(e:TEvent)
		'TODO: need to handle stuff in here
		If e.source = _tabber Then
			If e.id = EVENT_GADGETACTION Then
				showpanel TGUIPanel(e.extra)
			EndIf
		EndIf
	End Method

	Method Refresh()
		' not much to refresh
	End Method

	Method Gadget:TGadget()
		Return _tabber
	End Method

End Type

Type TGUIPanelGroup Extends TGUIContainer Final
	Field panels:TGUIPanel[]
	Field activepanel:TGUIPanel

	Method Initialise(gadget:TGadget,host:TGUIContainer)
		owner=host
		_gadget = gadget
	End Method

	Method AddPanel(panel:TGUIPanel)
		'panel.Initialize(name$,_gadget)
		panels=panels[..panels.length+1]
		panels[panels.length-1]=panel
		panel.index=panels.length-1
	End Method

	Method ShowPanel:Int(panel:TGUIPanel = Null , index:Int = Null)
		If panel=Null Then panel=panels[index]
		'find the panel, if present in this panel group
		For Local p:TGUIPanel = EachIn panels
			If p = panel Then
				' ensure the relevant panel is visible
				If activepanel<>Null Then activepanel.hide()
				activepanel = p
				activepanel.show()

				Return True
			EndIf
		Next
		Return False
	End Method

	Method Poll:Int(e:TEvent)
		If activepanel<>Null Then Return activepanel.poll(e)
	End Method

	Method Refresh()
		Local p:TGUIPanel
		For p=EachIn panels
			p.Refresh()
		Next
	End Method

	Method Invoke:Object(command:Int,argument:Object=Null)
		Return activepanel.Invoke(command,argument)
	End Method

	Method Query:Int(property:Int)
		Return activepanel.Query(property)
	End Method

End Type

Type TGUIGenericContainer Extends TGUIContainer Final

	Method CreateGenericContainer(n$ , x:Int , y:Int , w:Int , h:Int , host:TGUIContainer = Null)
		_gadget=CreatePanel(x,y,w,h,host.Gadget())
		SetGadgetLayout _gadget,1,1,1,1
		HideGadget _gadget
	End Method

	Method Poll(e:TEvent)
		'nothing relevant to a panel that is a simple panel...
	End Method

	Method Refresh()
		'nothing relevant to a panel that is a simple panel...
	End Method

	Method Invoke:Object(command:Int , argument:Object = Null)
		'nothing relevant to a panel that is a simple panel...
	End Method

	Method Query:Int(property:Int)
		'nothing relevant to a panel that is a simple panel...
	End Method
End Type

Type TGUIHintWindow Extends TGUIContainer
	Field _panel:TGadget
	Field _content:TGadget
	Field _font:TGUIFont
	Field IsOpen:Int

	Method Init( owner:TGUIContainer)
		?Debug
			If Not owner Then Throw "TGUIHintWindow .Init() needs a valid owner:TGUIContainer"
		?
		Self.owner = owner
		_gadget = CreateWindow( "HintWindow", 0,0, 128,32, owner._gadget, WINDOW_HIDDEN | WINDOW_CLIENTCOORDS)
		_panel = CreatePanel( 0,0, ClientWidth(_gadget),ClientHeight(_gadget), _gadget, PANEL_BORDER)
		_content = CreateLabel( "", 0,-4, ClientWidth(_panel),ClientHeight(_panel), _panel)
		SetGadgetLayout _panel, EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
		SetGadgetLayout _content, EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
		SetGadgetColor _content, 255,255,225, True
		_font = LookupGuiFont( GUIFONT_SYSTEM, 8 , FONT_ITALIC)
		SetGadgetFont _content, _font
		SetContent( "Hint Window")
	EndMethod

	Method Free()
		FreeGadget _gadget
		owner=Null 
	EndMethod

	Method Show()
		IsOpen = True
		ShowGadget _gadget
	EndMethod

	Method Hide()
		IsOpen = False
		HideGadget _gadget
	EndMethod

	Method ShowPos( x:Int,y:Int, w:Int=-1,h:Int=-1)
		If w = -1 Then w = _gadget.width
		If h = -1 Then h = _gadget.height
		SetGadgetShape _gadget, x,y, w,h
		Show()
	EndMethod

	Method SetContent( title:String, body:String=Null, autosize:Int=True)
		If body Then title :+ "~n~n" + body		
		If autosize Then
			'TODO: find a way to get proper size of a string
			Function GetTextSize( s:String, w:Int Var, h:Int Var)
				Local i:Int, l:Int
				Repeat
					l = i
					i = s.Find("~n", i)
					If i = -1 Then Exit
					If i-l > w Then w = i-l
					h :+ 1
					i :+ 1
				Forever
				If w <= 0 Then w = s.Length
				w :+ 3
				h :+ 1
			EndFunction
			
			Local w:Int,h:Int
			GetTextSize( title , w , h) 
			w :* FontSize(_font)*0.65 'fudge factor until a FontWidth or StringWidth is added...
			h :* FontSize(_font)*2.2  'fudge factor until a FontHeight or StringHeight is added...
			
			SetGadgetShape _gadget, _gadget.xpos,_gadget.ypos, w,h
		EndIf
		SetGadgetText _content, title
	EndMethod

	Method Poll(e:TEvent)
		If Not IsOpen Then Return
		Select e.ID
			Case EVENT_GADGETACTION
				If e.Source = _content Then Hide()
			Case EVENT_WINDOWCLOSE
				If e.Source = _gadget Then Hide() 
		EndSelect
	EndMethod

	Method Refresh()
	EndMethod

	Method Invoke:Object( command:Int, argument:Object = Null)
	EndMethod

	Method Query:Int(property:Int)
	EndMethod
EndType
