' BlitzMax SyncMods Tool

'superstrict

Type TBMXSyncModsRequester Extends TGUIToolWindow Final
	Field	label:TGadget,user:TGadget,password:TGadget,proxy:TGadget
	Field	options:TGadget[]
	Field	options_sync:TSyncOptions

	Method Refresh()
	End Method

	Method SyncMods()
		Local	u$ , p$ , x$ , cmd$ , i:Int , n:Int
		Local modules$[]
		
		modules=options_sync.modules
		u$=quote(TextFieldText(user))
		p$=quote(TextFieldText(password))
		x$=TextFieldText(proxy)
		cmd$=quote(bmxpath+"/bin/syncmods")
		cmd$:+" -u "+u$+" -p "+p$
		If x cmd$:+" -y "+x
		n=modules.length
		For Local i:Int=0 Until n
			If ButtonState(options[i]) cmd$:+" "+modules[i]
		Next
		Hide
		options_sync.syncstate=ToString()
		TGUIHost(owner).execute cmd,"@@output_panel/cmd_syncmods"',MENUTRIGGERDOCMODS
	End Method

	Method Poll(e:TEvent)
		Select e.source
			Case _gadget
				If e.id=EVENT_WINDOWCLOSE
					Hide
				EndIf
			Case _ok
				If e.id=EVENT_GADGETACTION Then SyncMods
			Case _cancel
				If e.id=EVENT_GADGETACTION Then Hide
		End Select
	End Method

	Method Invoke:Object(command:Int,argument:Object=Null)
		' there are no invocations relevant to a requester
	End Method

	Method Query:Int(property:Int)
		' there are no properties to query
	End Method

	Method Show()
		Super.Show()
		ActivateGadget user
	End Method

	Function Create:TBMXSyncModsRequester(host:TBMXHost)
		Local	sync:TBMXSyncModsRequester
		Local	win:TGadget
		Local	modules$[]

		sync=New TBMXSyncModsRequester
		sync.options_sync = host.options_sync
		modules=sync.options_sync.modules

		'Get the count of activated authors
		Local n:Int,y:Int,i:Int
		n=modules.length
		y=0
		For Local i:Int=0 Until n
			y:+26
		Next

		LanguageSetGroup "sync_mods_requester"

		win=sync.initToolWindow(host , "@@title" , 420 , 340 + y)

'		sync.label=CreateLabel(m$,8,20,380,160,win)
		sync.label=CreateTextArea(8,8,400,160,win,TEXTAREA_READONLY|TEXTAREA_WORDWRAP)

		SetGadgetText sync.label,"@@info"

		y=180

		CreateLabel("@@username",20,y+4,100,16,win)
		sync.user=CreateTextField(128,y,160,20,win)
		y:+30

		CreateLabel("@@password",20,y+4,100,16,win)
		sync.password=CreateTextField(128,y,160,20,win,TEXTFIELD_PASSWORD)
		y:+30

		CreateLabel("@@proxy_server",20,y+4,100,16,win)
		sync.proxy=CreateTextField(128,y,160,20,win)
		y:+30

		n=modules.length
		sync.options = New TGadget[n]
		For Local i:Int = 0 Until n
			sync.options[i]=CreateButton(modules[i],20,y,60,16,win,BUTTON_CHECKBOX)
			If i<2
				SetButtonState sync.options[i],True
				DisableGadget sync.options[i]
			EndIf
			Local s$=""			
			Try
				s$ = sync.options_sync.module_names[i]
			EndTry
			CreateLabel s$,100,y,300,16,win
			y:+26
		Next

		'and load the GUI based on the contents of the options type
		sync.FromString(sync.options_sync.syncstate)

		Return sync
	End Function

	Function GetArg$(a$ Var)
		Local 	p:Int,r$
		p=a.Find(",")+1
		If p=0 p=Len a$+1
		r$=a$[..p-1]
		a$=a$[p..]
		Return r$
	End Function

	Function Crypt$(a$)
		Local b$,c:Byte,i:Int
		For i=0 Until Len a
			c=a[i]
			If c>63 And c<192 c:~(i*-41)&63
			b:+Chr(c)
		Next
		Return b
	End Function

	Method FromString(s$)
		Local a$,i:Int,n:Int
		SetGadgetText user,GetArg(s$)
		SetGadgetText password,Crypt(GetArg(s$))
		SetGadgetText proxy,GetArg(s$)
		n=options_sync.modules.length
		While s$
			a$=GetArg(s$)
			For Local i:Int=2 Until n
				If a$=options_sync.modules[i] SetButtonState options[i],True
			Next
		Wend
	End Method

	Method ToString$()
		Local sync$,i:Int,n:Int
		sync=TextFieldText(user)
		sync:+","+Crypt(TextFieldText(password))
		sync:+","+TextFieldText(proxy)
		n=options_sync.modules.length
		For Local i:Int=2 Until n
			If ButtonState(options[i]) sync:+","+options_sync.modules[i]
		Next
		Return sync
	End Method
End Type

