' BlitzMax Build Modules Tool

'SuperStrict
'Import "requesters.bmx"
'Import "options.bmx"

Type TBMXBuildModsRequester Extends TGUIToolWindow Final
	Field	options:TGadget[]
	Field	options_build:TBuildOptions
	Field	p_native:TGadget , p_win:TGadget , p_uni:TGadget
	Field	t_single:TGadget , t_multi:TGadget
	Field	b_mod:TGadget , b_all:TGadget

	Method Refresh()
	End Method

	Method BuildModules(buildall:Int,threaded:Int,target:Int)
		Local cmd$,out$,exe$
		cmd$=quote(bmkpath)
		cmd$:+" makemods "
		If buildall cmd$:+ "-a "
		If threaded cmd$:+ "-h "
		' handle different target platforms
		Select target
				Case TARGETPLATFORM_NATIVE ; cmd$:+ ""
			?macosx86
				Case TARGETPLATFORM_WIN32 ; cmd$:+ "-l win32 "
				Case TARGETPLATFORM_MACOS_UNIVERSAL  ; cmd$:+ "-i "
			?linux
				Case TARGETPLATFORM_WIN32 ; cmd$:+ "-l win32 "
			?			
			Default
				Notify "@@error_message/msg_target_error";Return
		End Select
		TGUIHost(owner).Execute cmd,"@@output_panel/cmd_build_mods"
	End Method

	Method Poll(e:TEvent)
		Select e.source
			Case _gadget
				If e.id=EVENT_WINDOWCLOSE
					Hide
				EndIf
			Case _ok
				If e.id=EVENT_GADGETACTION Then 
					Local all:Int = ButtonState(b_all)
					Local thread:Int = ButtonState(t_multi)
					If ButtonState(p_native) Then
						BuildModules(all , thread , TARGETPLATFORM_NATIVE)
					ElseIf ButtonState(p_win) Then
						BuildModules(all , thread , TARGETPLATFORM_WIN32)
					ElseIf ButtonState(p_uni) Then
						BuildModules(all , thread , TARGETPLATFORM_MACOS_UNIVERSAL)
					Else
						Notify "Oops!"
					EndIf					
					Hide
				EndIf
			Case _cancel
				If e.id=EVENT_GADGETACTION Then Hide
		End Select
	End Method

	Method Invoke:Object(command:Int,argument:Object=Null)
		' there are no invocations relevant to a requester
	End Method

	Method Query:Int(property:Int)
		' there are no properties to query
	End Method

	Method Show()
		TBMXHost(owner).output.stop
		TBMXHost(owner).SaveAll
		Super.Show()
	End Method

	Function Create:TBMXBuildModsRequester(host:TBMXHost)
		Local	req:TBMXBuildModsRequester
		Local	modules$[]

		req=New TBMXBuildModsRequester
		req.options_build = host.options_build

		LanguageSetGroup "build_mods_requester"

		req.InitGUI(host)
		
		Return req
	End Function

	Method InitGUI(host:TBMXHost)
		Local	win:TGadget
		Local	p:TGadget , pp:TGadget
		
		win = initToolWindow(host , "@@title" , 620 , 180 )		
		pp=CreatePanel(10,10,ClientWidth(win)-20,120,win,PANEL_GROUP,"Build Options")
		p=CreatePanel(10,10,ClientWidth(pp)-20,30,pp)
		CreateLabel "@@build",0,0,150,24,p
		b_mod=CreateButton("@@modified",150,0,150,24,p,BUTTON_RADIO)
		b_all=CreateButton("@@all" , 300 , 0 , 150 , 24 , p , BUTTON_RADIO)

		p=CreatePanel(10,40,ClientWidth(pp)-20,30,pp)
		CreateLabel "@@threading",0,0,150,24,p
		t_single=CreateButton("@@single" , 150 , 0 , 150 , 24 , p , BUTTON_RADIO)
		t_multi=CreateButton("@@multi" , 300 , 0 , 150 , 24 , p , BUTTON_RADIO)	
		
		p=CreatePanel(10,70,ClientWidth(pp)-20,30,pp)
		CreateLabel "@@platform" , 0 , 0 , 150 , 24 , p
?win32
		p_native=CreateButton("@@windows" , 150 , 0 , 150 , 24 , p , BUTTON_RADIO)
?linux
		p_native=CreateButton("@@linux" , 150 , 0 , 150 , 24 , p , BUTTON_RADIO)
		p_win = CreateButton("@@windows" , 300 , 0 , 150 , 24 , p , BUTTON_RADIO)
		If Not FileType( BlitzMaxpath() + "/bin/bcc.exe" ) = FILETYPE_FILE Then DisableGadget p_win		
?macosppc
		p_native=CreateButton("@@macos" , 150 , 0 , 150 , 24 , p , BUTTON_RADIO)
?macosx86
		p_native=CreateButton("@@macos_intel" , 150 , 0 , 150 , 24 , p , BUTTON_RADIO)
		p_uni=CreateButton("@@macos_uni" , 300 , 0 , 150 , 24 , p , BUTTON_RADIO)
		p_win = CreateButton("@@windows" , 450 , 0 , 150 , 24 , p , BUTTON_RADIO)
		If Not FileType( BlitzMaxpath()+"/bin/bcc.exe" )=FILETYPE_FILE Then DisableGadget p_win
		If FileType( BlitzMaxpath()+"/bin/bcc_ppc" )<>FILETYPE_FILE Then DisableGadget p_uni
?		
		SetButtonState b_mod , True
		SetButtonState t_single , True
		SetButtonState p_native , True				
	End Method

End Type

