'bytebuffer.bmx
'
' This file seems to buffer an incoming stream?  Maybe this functionality will
' become part of the BRL.stream module at some point?

Import BRL.Stream

SuperStrict

Type TByteBuffer Extends TStream
	Field	bytes:Byte[]
	Field	readpointer:Int

	Method Read:Int( buf:Byte Ptr,count:Int )
		If count>readpointer count=readpointer
		If count=0 Then Return 0
		MemCopy buf,bytes,count
		readpointer:-count
		If readpointer MemMove bytes,Varptr bytes[count],readpointer
		Return count 
	End Method

	Method Write:Int( buf:Byte Ptr,count:Int )
		Local	n:Int,m:Int
		n=readpointer+count
		If n>bytes.length
			m=Max(bytes.length*1.5,n)
			bytes=bytes[..m]
		EndIf
		MemCopy Varptr bytes[readpointer],buf,count
		readpointer=n
		Return count
	End Method	
	
	Method LineAvail:Int()
		Local	i:Int
		For i=0 Until readpointer
			If bytes[i]=10 Return True
		Next
	End Method

	Method FlushBytes:Byte[]()
		Local res:Byte[]=bytes[..readpointer]
		readpointer=0
		Return res
	End Method
End Type
